.nolist
include \masm32\include\masm32rt.inc
.586
.xmm
include \masm32\macros\timers.asm	; MichaelW's timing macros, see attachment to top post in [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

  CheckResults=	1	; test correctness of results (will ignore patterns<8 bytes when used with Lingo's algo)
  ShowTheSvin=	0	; 1=show an older algo by [url=http://www.madwizard.org/programming/snippets?id=48]The Svin[/url]
  ShowBM=	0	; Boyer-Moore by [url=http://www.masm32.com/board/index.php?topic=4602.msg34249#msg34249]Hutch[/url]
  ShowCRT=	0	; C run-time library
  ShowCI=	0
  ShowLingoBM=	1	; Lingo's Boyer-Moore byte shift algo, crashes with patterns below 8 bytes
  CountFast=	100000	; put around 200000 to get stable timings for fast algos
  CountSlow=	10000	; put around 20000 for the slower algos
  OneByteScan=	0	; show results for one-byte patterns
  TestOldAlgo=	0	; show results for previous JJ algo
  UseLodsb=	1	; strangely enough, lodsb is a bit faster on Celeron M
  FindDuplicate=	1	; find "Duplicate inc" in Windows.inc (if DisplayCycles=1)
  DisplayCycles=	0	; 1=show the long list, 0=show only averages

COMMENT @ inspired by [url=http://www.masm32.com/board/index.php?topic=6181.msg46047#msg46047]InString Speed Test (Hutch)[/url]

One of the tested algos, InstrCi, knows three search modes, passed with the fourth para:
(default: StartPos = 1)

1.	invoke InstrCi, StartPos, addr Mainstr, addr SubstrxCi, 0
	start at pos 1, search case-sensitive for SubstrxCi in Mainstr

2.	invoke InstrCi, StartPos, addr Mainstr, addr SubstrxCi, 1
	start at pos 1, search case-insensitive for SubstrxCi in Mainstr

3.	invoke InstrCi, StartPos, addr Mainstr, addr SubstrxCi, 2
	start at pos 1, search for SubstrxCi in Mainstr, ignore case of first character

The first para indicates the start position. Use 1 for a standard search.
If this para is 0, then InstrCi continues directly after the last match.

You may use the FindString macro as follows:
FindString addr MainString, addr SubString [, sMode] [, sPos]
FindString addr MainString, addr SubString			; case-sensitive search starting at pos 1
FindString addr MainString, addr SubString, 1	; case-insensitive, default start at pos 1
FindString addr MainString, addr SubString, 0, 0	; case-sensitive, start at last match
FindString addr MainString, addr SubString, 2, 99	; first char case-insensitive, start pos 99
etc. @

    ShowCpu	PROTO:DWORD
    InStringL	PROTO :DWORD, :DWORD
    BMLinDB proto	:DWORD, :DWORD,:DWORD
    InstrCi	PROTO :DWORD, :DWORD, :DWORD, :DWORD
    InstrSse2	PROTO :DWORD, :DWORD, :DWORD, :DWORD
    InstrJJ	PROTO :DWORD, :DWORD, :DWORD, :DWORD
    InstrJJo	PROTO :DWORD, :DWORD, :DWORD, :DWORD
    InstrSse2D	PROTO :DWORD, :DWORD, :DWORD, :DWORD
    finstr	PROTO :DWORD, :DWORD, :DWORD
    InStringTheSvin	PROTO :DWORD, :DWORD, :DWORD
    BM	PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
    BMLin12	PROTO :DWORD, :DWORD,:DWORD

timings MACRO algo, a1, a2, a3, a4, a5, a6
LOCAL tmp$, out$, Description
  ifndef CurAlgo
  	CurAlgo equ <>
  endif
  ifdif CurAlgo, <algo>
  	CurAlgo equ <algo>
  endif
  ifidni CurAlgo, <_imp__strstr>
	Description equ <CRT_strstr>
	% echo Description
  else
	Description equ CurAlgo
  endif

  tmp$ CATSTR <invoke >, <algo>
  ifnb <a1>
	tmp$ CATSTR tmp$, <, >, <a1>
	Description CATSTR Description, <, >, <a1>
  ifnb <a2>
	tmp$ CATSTR tmp$, <, >, <a2>
	Description CATSTR Description, <, >, <a2>
  ifnb <a3>
	tmp$ CATSTR tmp$, <, >, <a3>
	Description CATSTR Description, <, >, <a3>
  ifnb <a4>
	tmp$ CATSTR tmp$, <, >, <a4>
	Description CATSTR Description, <, >, <a4>
  ifnb <a5>
	tmp$ CATSTR tmp$, <, >, <a5>
	Description CATSTR Description, <, >, <a5>
  endif
  endif
  endif
  endif
  endif
  ifndef globcycles		;; we might need to calculate a global average count
  	.data?
  	globcycles	dd ?
  	globcount	dd ?
  	.code
  endif
  .if globcycles==0
  	and globcount, 0		;; sufficient to clear the cycles
  	if DisplayCycles
		print chr$(13, 10)
  	endif
  .endif
  ifndef REP_CT
	REP_CT = 1
  endif
  ifndef REP_CTold
	REP_CTold = REP_CT
  endif
  if REP_CT gt 1
  	if REP_CTold eq 1
		print chr$(13, 10)
	endif
	REP_CTold = REP_CT
  endif
  ;% echo tmp$			;; uncomment to see what exactly you are invoking
  REPEAT REP_CT
	invoke Sleep, 50
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		tmp$
	counter_end
	add globcycles, eax
	inc globcount
	if DisplayCycles
	.if eax>65536
		shr eax, 10
	.endif
	out$ CATSTR <print str$(eax), 9, ">, Description, <", 13, 10>
	out$
	endif
  ENDM
  if REP_CT gt 1
	if DisplayCycles
		print chr$(13, 10)
	endif
  endif
ENDM

csize macro algo
LOCAL  tmp$
  tmp$ CATSTR <algo>, <            >
  tmp$ SUBSTR tmp$, 1, 12
  tmp$ CATSTR <print ">, tmp$, < = ">
  tmp$
  mov eax, offset &algo&e-&algo&
  print str$(eax), 13, 10
ENDM

itest MACRO src, pattern
pushad
	invoke InstrCi, 1, addr src, addr pattern, 0		; 1=case-insensitive
	mov GoodResult, ecx
	ifidn TestMe, <BMLinDB>
		if (SIZEOF pattern) ge 9
			invoke BMLinDB, addr src, addr pattern, (SIZEOF pattern)-1
			inc eax
		else
			mov eax, 12345678h	; magic
		endif
	elseifidn TestMe, <BM>
		if (SIZEOF pattern) ge 9
			invoke BM, 0, addr src, len(offset src), addr pattern, (SIZEOF pattern)-1
		else
			mov eax, 12345678h	; magic
		endif
	else
		invoke TestMe, 1, addr src, addr pattern, 0
	endif
	.if eax==GoodResult
		if 0
		push eax
		print chr$(13, 10, "&src&, &pattern&:  ", 9)
		pop eax
		print str$(GoodResult), 9, "OK"
		endif
		if 0
		print "  t1="
		print str$(tjj1)
		print "  t2="
		print str$(tjj2)
		endif
	.elseif eax==12345678h
		print chr$(13, 10, "-   ",9, "pattern too short for BMLinDB")
	.else
		push eax
		print chr$(13, 10, "&src&, &pattern&:  ", 9)
		pop eax
		push eax
		print str$(eax), 9, "expected "
		print str$(GoodResult), ", d="
		pop eax
		sub eax, GoodResult
		print str$(eax)
		inc BadResults
	.endif
popad
ENDM

FindString MACRO pMain:REQ, pSub:REQ, sMode:=<0>, sPos:=<1>
  invoke InstrCi, sPos, pMain, pSub, sMode
ENDM

; Collake macros

; ====( StrCmp )==== 
; Case sensitive reverse direction string compare macro.
; + assumes last character of both strings are equal!
; entry:  esi->end of string1
;         ebx->end of string2
;         ecx=length of string
; returns:
;         zero flag set if equal
; destroyed:
;         eax,esi,ebx,ecx
;
RevStrCmp MACRO
LOCAL RevStrCmpLoop,RevStrCmpEnd
        dec     ecx
        jz      RevStrCmpEnd
RevStrCmpLoop:  
        dec     esi
        dec     ebx     
        mov     al,byte ptr [esi]
        cmp     al,byte ptr [ebx]
        jnz     RevStrCmpEnd    
        dec     ecx
        jnz     RevStrCmpLoop
RevStrCmpEnd:           
ENDM

; ====( RevStrCmpi )==== 
; Case insensitive reverse string compare macro.
; + assumes last character of both strings are equal!
; entry:  esi->string1 
;         edi->string2 
;         ecx=length of string
; returns:
;         zero flag set if equal
; destroyed:
;         eax,esi,edi,ecx

RevStrCmpi MACRO
LOCAL RevStrCmpiLoop,RevStrCmpiEnd
        dec     ecx
        jz      RevStrCmpiEnd
RevStrCmpiLoop: 
        dec     esi
        dec     ebx
        mov     al,byte ptr [esi]       
        mov     ah,byte ptr [ebx]        
        cmp     al,ah
        jz      RevStrCmpiContLoop
        ToLower al        
        ToLower ah        
        cmp     al,ah
        jnz     RevStrCmpiEnd   
RevStrCmpiContLoop:        
        dec     ecx
        jnz     RevStrCmpiLoop
RevStrCmpiEnd:          
ENDM
;
; ====( ToLower )==== 
; Macro to convert ANSI character to lowercase
;
ToLower MACRO reg8
        LOCAL   nochg
        cmp     reg8,'A'
        jb      nochg
        cmp     reg8,'Z'
        ja      nochg
        sub     reg8,'A'-'a'
nochg:  
ENDM

BMTABLE STRUCT
    dd 256 dup(0)
BMTABLE ENDS


.data
SmPat1	db "X", 0
SmPat2	db "X6", 0
SmPat3	db "X67", 0
SmPat4	db "X678", 0
SmPat5	db "X6789", 0
SmPat6	db "X67890", 0
SmPat7	db "X678901", 0
SmPat8	db "X6789012", 0
SmPat9	db "X67890123", 0

	db 1, 2, 3, 4, 5, 6, 7, 8
SzTest1	db "Short test with match string at end: Here it is", 0
SzMatch1	db "Here it is", 0  

FindInWinInc	db "Duplicate inc", 0

align 16
; SmSrcA	db "12345678901234X6789?12345678901234X678901234567890", 0 ;, "X67890"
SmSrcA	db "12345678901234x6789?12345678901234x678901234", 0, "X67890"	; pattern +2, nullbyte +C

align 16
	db 1, 2, 3, 4, 5, 6, 7
SmSrcUE	db "123456789012a4X6789", 0 ;, "X67890" 	; we add a SmPat6 to test whether the algo can handle that

align 16
	db 1
SmSrcU	db "123456789012a4X67890?2345b78901234X67890c234567890X67890x2X6789012345", 0, "X67890"

align 16
	db 1, 2
SmSrcU2	db "123456789012a4X6789?12345b78901234X6789c1234567890", 0, "X67890"
align 16
	db 1, 2, 3
SmSrcU3	db "123456789012a4X6789?12345b78901234X6789c1234567890", 0, "X67890"
align 16
	db 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15
SmSrcU15	db "123456789012a4X6789?12345b78901234X6789c1234567890", 0, "X67890"

align 16
BigSrcA	db 20 dup ("123456789012345678901234567890")
	db "12345678901234X6789?12345678901234X678901234567890", 0 ;, "X67890" ; seems to cost 50 cycles!?
align 16
	db 1, 2, 3, 4, 5, 6, 7	;, 8, 9, 10, 11, 12, 13
BigSrcU	db 20 dup ("123456789",0aah,"12345678901234567890")
	db "12345678901234X6789?12345678901234X678901234567890", 0

; 
PigString equ <"The time has come the walrus said to speak of many things, of birds + bugs + ceiling wax, of cabbages and kings. And if the sea is boiling hot and whether pigs have wongs ">
; 
align 16
	db 1, 2, 3, 4, 5, 6, 7	; misaligned by 7 bytes
Mainstr	db 14 dup(PigString)
	db "... of bugs and ceiling waX, of cabbages. And if the sea is boiling hot "
	db "and whether pigs have wings and fly like elephants in the sky...", 0, "skyxxxxxxxxxxx"

Substrx	db "wings", 0	; for the first three algos, crt_strstr, finstr and InStringL
SubstrxCi	db "Wings", 0
SubstrxCiL	db "Wings and fly like elephants in the sky", 0
TestSubE	db "X, of cabbag", 0	; easy one, there is only one uppercase X in Mainstr
TestSubD	db "wings", 0		; slightly more difficult, 56*w in Mainstr
; TestSubX	db "elephants", 0		; extremely difficult for a byte scanner - e is the most common character
TestSubX	db "e wings", 0		; seems even more difficult for MasmLib InstringL ;-)

; 8-byte versions for Lingo's algo:
TestSubEx	db "X, of ca", 0		; easy one, there is only one uppercase X in Mainstr
TestSubDx	db "wings an", 0		; slightly more difficult, 56*w in Mainstr
TestSubXx	db "e wings ", 0		; seems even more difficult for MasmLib InstringL ;-)


; this yields a correct result (pos 2616) for the BM algo:
; BM_long	db "ve wings and fly like elephants in the sky", 0
BM_long	db "elephants", 0
; BM_longOk	db "ve wi", 0

; these variants yields wrong results for the Boyer-Moore algo:
BM_longWR1	db "ave wings and fly like elephants in the sky", 0
BM_longWR2	db "ave wi", 0

cl1	dd 0
cl2	dd 0
cl3	dd 0
cl4s1	dd 0	; short pattern, mode 1 = case insensitive
cl4s2	dd 0	; short pattern, mode 2 = first char case insensitive
cl4l1	dd 0	; long pattern, mode 1 = case insensitive
cl4l2	dd 0	; long pattern, mode 2 = first char case insensitive
cl4t	dd 0
cl4t1	dd 0
cl4t2	dd 0
cl5	dd 0
cl6s	dd 0
cl6l	dd 0
cl7	dd 0
cl8	dd 0	; Collake
cl8iS	dd 0
cl8iL	dd 0
cl9a	dd 0	; Lingo
cl9b	dd 0	; Lingo

.data?
align 16
tabl qword  64*16 Dup(?)
align 16

;  ShiftTable     DWORD 256 DUP (?)

fbuffer	dd ?
flen	dd ?

res1	dd ?
res2	dd ?
res3	dd ?
res4s1	dd ?
res4s2	dd ?
res4l1	dd ?
res4l2	dd ?
res5	dd ?
res6s	dd ?
res6l	dd ?
res7	dd ?
res8	dd ?	; Collake
res8iS	dd ?	; Collake
res8iL	dd ?	; Collake
res9a	dd ?	; Lingo
res9b	dd ?	; Lingo
GLEN	dd ?
CurPos	dd ?
plenS	dd ?
plenL	dd ?
slen	dd ?
GoodResult	dd ?
BadResults	dd ?
tjj1	dd ?
tjj2	dd ?
tijj	dd ?
jjdiff	dd ?
LibCycles	dd ?
LingoCycles	dd ?
BMCycles	dd ?

.code
start:	
	LOOP_COUNT = CountSlow
	TestMe equ InstrJJ
	; TestMe equ BMLinDB				; Lingo's BM code doesn't work for short patterns (by design)
	; TestMe equ InstrSse2
	; TestMe equ BM						; fails for Mainstr, TestSubEx only

	invoke ShowCpu, 1						; ***** show which CPU you are running ****
	;inc tjj1
	itest SmSrcU, SmPat7
	if FindDuplicate
	if DisplayCycles
	invoke read_disk_file, chr$("\masm32\include\windows.inc"), offset fbuffer, offset flen
	.if eax
		LOOP_COUNT = 500
		print chr$(13, 10, "Find 'Duplicate inc' in Windows.inc (kCycles):", 13, 10)
		timings InstrJJ, 1, fbuffer, offset FindInWinInc, 0
		timings BMLinDB, fbuffer, offset FindInWinInc, (SIZEOF FindInWinInc)-1
		timings InString, 1, fbuffer, offset FindInWinInc
 		; invoke GlobalFree, fbuffer
 		print chr$(13, 10)
	.else
		print chr$(13, 10, "reading windows.inc failed")
	.endif
	endif
	endif

	if CheckResults
		; tests various combinations of Mainstring, Pattern for the selected TestMe algo only
		tmp$ CATSTR <print chr$("Test correctness for >, TestMe, <:")>
		tmp$
		if FindDuplicate
			itest fbuffer, FindInWinInc
		endif
	itest SmSrcA, SmPat1

	itest Mainstr, TestSubEx
	itest Mainstr, TestSubDx
	itest Mainstr, TestSubXx
	itest SzTest1, SzMatch1
	itest SmSrcUE, SmPat2
	itest BigSrcA, SmPat2
	itest BigSrcU, SmPat2
	itest SmSrcU, SmPat2
	
	itest SmSrcU2, SmPat5
	itest SmSrcU3, SmPat5
	itest SmSrcU15, SmPat5
	itest BigSrcA, SmPat1
	itest BigSrcU, SmPat1
	itest BigSrcA, SmPat2
	itest BigSrcU, SmPat2
	itest BigSrcA, SmPat3
	itest BigSrcU, SmPat3
	itest BigSrcA, SmPat4
	itest BigSrcU, SmPat4
	itest BigSrcA, SmPat5
	itest BigSrcU, SmPat5
	itest BigSrcA, SmPat6
	itest BigSrcU, SmPat6
	itest BigSrcA, SmPat7
	itest BigSrcU, SmPat7

	; itest SmSrcA, SmPat1
	itest SmSrcU, SmPat1
	itest SmSrcA, SmPat2
	itest SmSrcU, SmPat2
	itest SmSrcA, SmPat3
	itest SmSrcU, SmPat3
	itest SmSrcA, SmPat4
	itest SmSrcU, SmPat4
	itest SmSrcA, SmPat5
	itest SmSrcU, SmPat5
	itest SmSrcA, SmPat6
	itest SmSrcU, SmPat6
	itest SmSrcA, SmPat7
	; inc tijj
	itest SmSrcU, SmPat7

	itest Mainstr, TestSubE
	itest Mainstr, TestSubD
	itest Mainstr, TestSubX
	endif
	.if BadResults==0
		print " OK"
	.endif
	TestMe equ InstrJJ
	if DisplayCycles
		print chr$(13, 10, 10, "Cycle counts:")
	endif
	if ShowCRT
	and globcycles, 0	; global cycles
	timings crt_strstr, addr Mainstr, addr TestSubE
	timings crt_strstr, addr Mainstr, addr TestSubD
	timings crt_strstr, addr Mainstr, addr TestSubX
	endif
	if ShowCI
	and globcycles, 0	; global cycles
	timings InstrCi, 1, addr Mainstr, addr TestSubE, 0
	timings InstrCi, 1, addr Mainstr, addr TestSubD, 0
	timings InstrCi, 1, addr Mainstr, addr TestSubX, 0
	endif
	
	sMain = SIZEOF Mainstr

	if ShowBM			; this algo is fast also because the length must be passed!
	and globcycles, 0	; global cycles
	timings BM, 0, addr Mainstr, sMain, addr TestSubEx, (SIZEOF TestSubEx)-1
	timings BM, 0, addr Mainstr, sMain, addr TestSubDx, (SIZEOF TestSubDx)-1
	timings BM, 0, addr Mainstr, sMain, addr TestSubXx, (SIZEOF TestSubXx)-1
	mov eax, globcycles
	cdq
	div globcount
	mov BMCycles, eax
	endif

	if ShowLingoBM
	and globcycles, 0	; global cycles
	timings BMLinDB, addr Mainstr, addr TestSubEx, (SIZEOF TestSubEx)-1
	timings BMLinDB, addr Mainstr, addr TestSubDx, (SIZEOF TestSubDx)-1
	timings BMLinDB, addr Mainstr, addr TestSubXx, (SIZEOF TestSubXx)-1
	mov eax, globcycles
	cdq
	div globcount
	mov LingoCycles, eax
	endif

	if ShowTheSvin
	and globcycles, 0
	timings InStringTheSvin, 1, addr Mainstr, addr TestSubE
	timings InStringTheSvin, 1, addr Mainstr, addr TestSubX
	endif

	and globcycles, 0
	timings InString, 1, addr Mainstr, addr TestSubE
	timings InString, 1, addr Mainstr, addr TestSubD
	timings InString, 1, addr Mainstr, addr TestSubX
	mov eax, globcycles
	cdq
	div globcount
	mov LibCycles, eax

	LOOP_COUNT  = CountFast

	and globcycles, 0

	REP_CT = 3
	timings TestMe, 1, addr Mainstr, addr TestSubE, 0
	timings TestMe, 1, addr Mainstr, addr TestSubD, 0
	timings TestMe, 1, addr Mainstr, addr TestSubX, 0

	print chr$("Average cycle counts:" , 13, 10)
	mov eax, globcycles
	cdq
	div globcount
	mov jjdiff, eax
	print str$(eax), 9, " InstrJJ (jj2007)", 13, 10
	if ShowLingoBM
		print str$(LingoCycles), 9, " BMLinDB (Lingo)", 13, 10
	endif
	if ShowBM
		print str$(BMCycles), 9, " BM (Boyer-Moore Hutch)", 13, 10
	endif
	print str$(LibCycles), 9, " InString (Masm32 Lib)", 13, 10, "InstrJJ : InString = "

	mov eax, globcycles	; InstrJJ cycles
	m2m ecx, 100			; *100
	mul ecx					; result in eax
	cdq
	div globcount			; per count
	cdq
	mov ecx, LibCycles
	div ecx
	print str$(eax), " %", 13, 10, 10, "Code sizes:", 13, 10
	csize InstrJJ
	if ShowBM
		csize BM
	endif
	if ShowLingoBM
		csize BMLinDB
	endif
	;csize finstr
	csize InStringL

	if TestOldAlgo
	and globcycles, 0	; global cycles

	REP_CT = 3
	timings InstrJJo, 1, addr Mainstr, addr TestSubE, 0
	timings InstrJJo, 1, addr Mainstr, addr TestSubD, 0
	timings InstrJJo, 1, addr Mainstr, addr TestSubX, 0

	print chr$(13, 10, "Average cycle count InstrJJo:" , 9)
	mov eax, globcycles
	cdq
	div globcount
	sub jjdiff, eax
	print str$(eax), ", diff="
	print str$(jjdiff), 13, 10
	csize InstrJJo
	endif

	if OneByteScan
	print chr$(13,10,10, "Small patterns:")
	itest Mainstr, SmPat2
	itest Mainstr, SmPat1
	itest BigSrcU, SmPat2
	itest BigSrcU, SmPat1
	print chr$(13, 10, 10)

	REP_CT = 1
	timings TestMe, 1, addr Mainstr, addr SmPat2, 0
	timings TestMe, 1, addr Mainstr, addr SmPat1, 0
	timings TestMe, 1, addr BigSrcU, addr SmPat2, 0
	timings TestMe, 1, addr BigSrcU, addr SmPat1, 0
	endif
	.if fbuffer
		invoke GlobalFree, fbuffer
	.endif
	getkey
	exit

; 
OPTION PROLOGUE:NONE			; turn it off
OPTION EPILOGUE:NONE			;
align 16						;
InStringL	proc lpSource:DWORD, lpPattern:DWORD
	mov		eax, [esp+1*4]		; eax-> lpSource
    mov		edx, [esp+2*4]		; edx->lpPattern
    movzx	ecx, byte ptr [edx] ; ecx->the 1st byte of substring
	mov		[esp+2*4], esi		; saving register esi
    imul	ecx, 1010101h       ; ecx=77 77 77 77h  ; 77h -> ASCII code of "w"
	mov		[esp+1*4], ebx		; saving register ebx
	lea		esi, [edx+1]		; esi->lp Pattern +1
BytesScan:						;
	mov		edx, ecx			; edx=77 77 77 77h  ; 77h -> ASCII code of "w"
	xor		ebx, ebx			;
@@:								;
	xor		ecx, [eax]			;
	add		eax, 4				;              
	add		ecx, 0FEFEFEFFh		;   
    test	ecx, 080808080h		;   
	mov		ecx, edx			; edx=77 77 77 77h  ; 77h -> ASCII code of "w"
  	je		@b					; 
								;
    cmp		[eax-4], dl			; dl ->1st byte of pattern
    lea		eax, [eax-3]	
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]	
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]
	jne		@b
@@:								; CMP rest  of strings
	add		bl,	 [esi]
	je		@found	
	sub		bl,	 [eax]
	jne		BytesScan
	add		bl,	 [esi+1]
	je		@found	
	sub		bl,	 [eax+1]
	jne		BytesScan
	add		bl,	 [esi+2]
	je		@found	
	sub		bl,	 [eax+2]
	jne		BytesScan
	add		bl,	 [esi+3]
	je		@found	
	sub		bl,	 [eax+3]
	jne		BytesScan	
	add		bl,	 [esi+4]
	je		@found	
	sub		bl,	 [eax+4]
	jne		BytesScan
	add		bl,	 [esi+5]
	je		@found	
	sub		bl,	 [eax+5]
	jne		BytesScan
	add		bl,	 [esi+6]
	je		@found	
	sub		bl,	 [eax+6]
	jne		BytesScan
	add		bl,	 [esi+7]
	je		@found	
	sub		bl,	 [eax+7]
	jne		BytesScan
	add		bl,	 [esi+8]
	je		@found	
	sub		bl,	 [eax+8]
	jne		BytesScan
	mov		edx, 8
@@:	
	add		bl,	 [esi+edx+1]
	je		@found	
	sub		bl,	 [eax+edx+1]
	jne		BytesScan
	add		bl,	 [esi+edx+2]
	je		@found	
	sub		bl,	 [eax+edx+2]
	jne		BytesScan
	add		bl,	 [esi+edx+3]
	je		@found	
	sub		bl,	 [eax+edx+3]
	jne		BytesScan
	add		bl,	 [esi+edx+4]
	je		@found	
	sub		bl,	 [eax+edx+4]
	jne		BytesScan
	add		edx, 4
	jne		@b
@found:	
	mov		ebx, [esp+1*4]	 
	cmp		eax, esi		
	mov		esi, [esp+2*4]	 
	sbb		ecx, ecx
	mov		edx, [esp]	 
	add		eax,  -1		
	add		esp, 3*4 
	and		eax, ecx		;eax-> address of 1st occurrence or 0->Not found   
	jmp		edx
InStringL	endp
InStringLe:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

finstr proc spos:DWORD,psrc:DWORD,patn:DWORD

    .data?
      align 16
      _ebx dd ?
      _esi dd ?
      _edi dd ?
      _ebp dd ?
    .code

    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp

    mov ebp, 1
    mov edi, [esp+12]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st patn byte in AL
    mov esi, [esp+8]                ; psrc
    add esi, [esp+4]                ; spos
    sub esi, ebp

; --------------------

  align 16
  scanloop:
  REPEAT 15
    add esi, ebp
    movzx edx, BYTE PTR [esi]
    cmp eax, edx
    je prematch
    test edx, edx                   ; test for source terminator
    jz no_match
  ENDM

    add esi, ebp
    movzx edx, BYTE PTR [esi]
    cmp eax, edx
    je prematch
    test edx, edx                   ; test for source terminator
    jnz scanloop
    jmp no_match

; --------------------

  align 16
  prematch:
    xor ebx, ebx

; --------------------

  matchloop:
  REPEAT 7
    add ebx, ebp
    movzx ecx, BYTE PTR [esi+ebx]
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match
    cmp ecx, edx
    jne scanloop
  ENDM

    add ebx, ebp
    movzx ecx, BYTE PTR [esi+ebx]
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match
    cmp ecx, edx
    jne scanloop
    jmp matchloop

; --------------------

  match:
    sub esi, [esp+8]                ; psrc
    mov eax, esi
    jmp cleanup

  no_match:
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 12

finstr endp
finstre:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 16
InstrSse2 proc StartPos:DWORD, lpSource:DWORD, lpPattern:DWORD, sMode:DWORD
	push esi
	push edi
	push ebx					; all registers preserved, except eax = return value
	push ebp
	push ecx
	push edx

	;and tjj1, 0
	;and tjj2, 0

	mov esi, [esp+6*4+2*4]		; lpSource
	mov edx, [esp+6*4+3*4]		; lpPattern
	mov edi, [edx+1]				; next 4 bytes of pattern
	mov eax, edi
	or ebx, -1
	.if al==0
		xor ebx, ebx
		mov edi, ebx
	.elseif ah==0
		movzx ebx, bl
		and edi, ebx
	.else
		shr eax, 16
		.if al==0
			movzx ebx, bx		; = and ebx, 0FFFFh
		.elseif ah==0
			and ebx, 0FFFFFFh
		.endif
	.endif
	and edi, ebx					; apply mask for bytes 2-5
	movzx eax, byte ptr [edx]

	imul eax, 01010101h			; propagate byte 1
	movd xmm3, eax
	pshufd xmm3, xmm3, 0		; xmm3 holds first byte of pattern

	mov ebp, esi
	and ebp, 15						; extract offset unaligned-aligned
	je L1							; if aligned, go directly into the main loop
	movups xmm1, [esi]			; load 16 bytes from current unaligned address
	and esi, -16						; align esi downwards
	jmp @F
L1:	movaps xmm1, [esi]			; load 16 bytes from current aligned address
	xor ebp, ebp					; zero the remainder in first aligned loop
@@:	movaps xmm2, xmm1			; save 16 bytes for testing the zero delimiter
	; inc tjj1
	pcmpeqb xmm1, xmm3		; compare packed bytes in xmm1 and xmm3 (elephant) for equality
	pcmpeqb xmm2, xmm1		; xmm1 is filled with either 0 or FF; if it's FF, the byte at that position cannot be zero
	lea esi, [esi+16]				; len counter (moving up/down lea or add costs cycles)
	pmovmskb edx, xmm1		; set byte mask in edx for search pattern byte
	pmovmskb ecx, xmm2			; set byte mask in ecx for zero delimiter
	test ecx, ecx					; zero byte found?
	jnz ChkNull
	test edx, edx					; pattern byte found?
	jz L1

@@:	bsf ecx, edx						; bit scan for the index --------------------------
	lea eax, [esi+ecx-15]
	mov eax, [eax+ebp]			; first unaligned chunk contains match
	btr edx, ecx						; clear bit ecx in edx
	and eax, ebx
	cmp eax, edi
	je FoundPattern
BadLuck:
	test edx, edx
	jnz @B							; bit scan end ------------------------------------------
	jmp L1							; 0=no more hits in these 16 bytes, go back searching

	; jz L1		; much slower version
	; jmp @B

ChkNull:
	xor eax, eax
	test edx, edx
	je NoMatch
	bsf eax, ecx					; nullbyte index in eax
	bsf ecx, edx					; pattern byte index in ecx
	cmp eax, ecx				; null before pattern byte: outta here
	jb NoMatch
	cmp [esi+ecx-15], edi
	jne NoMatch				; buggy: we should check until edx=0

FoundPattern:						; we need to check the complete string here
	test edi, edi					; one-byte pattern?
	je Match
	; inc tjj2
	push edi
	push esi
	mov edi, [esp+6*4+3*4+8]		; lpPattern
	lea esi, [esi+ecx-15-1]
	add esi, ebp

@@:	inc edi
	inc esi
	movzx eax, byte ptr [edi]
	test eax, eax
	je @F
	cmp al, byte ptr [esi]
	je @B

@@:	pop esi
	pop edi
	test eax, eax
	jne BadLuck
	; mov eax, tjj1	; test var 1
	; mov edx, tjj2	; test var 2
Match:
	sub esi, [esp+6*4+2*4]	; lpSource: subtract original src pointer
	lea eax, [esi+ecx-15]		; and adjust for the index
	add eax, ebp				; ebp = offset in first unaligned chunk

NoMatch:
	pop edx		; 6 registers
	pop ecx
	pop ebp
	pop ebx
	pop edi
	pop esi
	; dec eax
	ret 4*4		; 4 arguments
InstrSse2 endp
InstrSse2e:

align 16
InstrJJ proc StartPos:DWORD, lpSource:DWORD, lpPattern:DWORD, sMode:DWORD
;	sMode is reserved for a future implementation of a "ignore case of first character" mode
	push esi
	push edi
	push ebx					; all registers preserved, except eax = return value
	push ebp
	push ecx
	push edx
	; and tjj1, 0
	mov esi, [esp+6*4+2*4]		; lpSource
	mov edx, [esp+6*4+3*4]		; lpPattern
	movzx ecx, byte ptr [edx]	; 3 cycles to fill xmm0 with first byte
;	movzx eax, word ptr [edx]	; 3 cycles to fill xmm3 with first word
	; test ah, ah
	; je ByteScan
	mov edi, [edx+1]				; next 4 bytes of pattern
	imul ecx, 01010101h			; propagate lobyte
	movd xmm0, ecx
	pshufd xmm0, xmm0, 0		; xmm0 holds first byte of pattern
	mov eax, edi
	or ebx, -1
;	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
	.if al==0
		inc ebx							; clr ebx, pattern byte 2 is zero
		mov edi, ebx					; clear edi
	.elseif ah==0
		movzx ebx, bl					; byte 3 is zero (= and ebx, 0ffh)
		and edi, ebx
	.else
		bswap eax						; one byte shorter, and a bit faster than shr eax, 16
		test ah, ah						; must come first; if not zero, test new al (highest byte before swap)
		.if Zero?
			movzx ebx, bx			; byte 4 is zero (= and ebx, 0ffffh)
		.else
			test al, al					; highest byte before swap
			.if Zero?
				shr ebx, 8				; byte 5 is zero (= ebx, 0ffffffh but faster and shorter) 
			.endif
		.endif
	.endif
	and edi, ebx					; apply mask for pattern bytes 2-5
	test esi, 15						; aligned?
	je L0							; if yes, clear ebp and go directly into the main loop
	lea ebp, [esi+16]				; save unaligned address+16
	movdqu xmm2, [esi]			; load 16 bytes from current unaligned address
	and esi, -16						; align esi downwards
	jmp Lu
	Repeat 0
	nop								; 4=1666, 0=1672
	Endm
L0:	xor ebp, ebp					; clear the alignment flag ----------------------------------------------------------------------
L1:	movdqa xmm2, [esi]
Lu:	movdqa xmm1, xmm0			; xmm0 has first byte of pattern
	lea esi, [esi+16]				; position in mainstring (moving up/down lea or add costs cycles; add esi, 16 is 5 cycles slower on CM, 8 on P4)
	pcmpeqb xmm1, xmm2		; compare memory to pattern byte
	pmovmskb edx, xmm1		; set byte mask in edx for search pattern byte
	pcmpeqb xmm1, xmm2		; look for zero byte (xmm1 is either 0 or ff)
	pmovmskb eax, xmm1		; set byte mask in eax for zero delimiter byte
	test eax, eax					; db 02eh	; branch hint: not taken, no effect
	jne ZBF						; zero byte found? check/clear ebp, then ChkNull
	test edx, edx					; db 03eh	; branch hint: taken, no effect
	je L1							; pattern byte found? no=go back, yes=repeat the exercise with a word

@@:	test ebp, ebp					; 0=aligned from the beginning, or at least second loop
	jne EbpChk					; rare case, once per algo and only if Mainstring is unaligned - so try not to branch

@@:
	REPEAT 3						; 4 same as 3, 1+5 worse: 1=+300, 2=+30
	  bsf ecx, edx					; bit scan for the index ---------------------------------------------------------
	  btr edx, ecx					; clear bit ecx in edx (no add ecx, ebp here: 0.5*171=+85 cycles)
	  mov eax, [esi+ecx-14-1]	; first unaligned chunk contains match; this loop 171 times for TestSubX
	  and eax, ebx					; apply mask
	  cmp eax, edi
	  je FoundPattern
	  test edx, edx
	  je L1							; mysteriously, jmp L0 was consistently ca. 10 cycles faster than jmp L1...
	ENDM
	jmp @B							; 0=no more hits in these 16 bytes, go back searching (this order is here a lot faster)

EbpChk:
	sub ebp, esi					; ebp>0, might be first unaligned loop
	jns @F
	xor ebp, ebp					; ebp<esi: we are at least in the second loop, i.e. 16-byte aligned
	; jmp @B		; needed??	

@@:	bsf ecx, edx						; bit scan with misalignment offset in ebp -----------------------
	btr edx, ecx						; clear bit ecx in edx
	add ecx, ebp					; ebp is the misalignment offset, needed for the whole bitscan loop
	mov eax, [esi+ecx-15]			; first unaligned chunk contains match
	and eax, ebx					; apply mask
	cmp eax, edi
	je FoundPatternSubEcx		; corrects increased ecx

BadLuck:
	if 0
	xor eax, eax					; default: no match
	cmp ebx, -123					; flag end??
	je NoMatch
	endif

	test edx, edx
	je L0						; unaligned bit scan end, time to clear ebp in L0 -------------
	jmp @B

ZBF:	sub ebp, esi				; ebp>0, might be first unaligned loop
	jns ChkNull
	xor ebp, ebp				; ebp<esi: we are at least in the second loop, i.e. 16-byte aligned

ChkNull:							; this branch only if a nullbyte was found in Mainstring
	bsf ebx, eax				; nullbyte index to ebx
	xor eax, eax				; default: 0=no match
	test edx, edx				; edx holds pattern index
	je NoMatch
	bsf ecx, edx					; pattern word index in ecx
	cmp ebx, ecx				; null before pattern word: get outta here
	jb NoMatch
	add ecx, ebp				; jmp FoundPattern is slower
;	m2m ebx, -123				; flag end
	;				0						 16			 32			48 51
	;SmSrcU	db "123456789012a4X67890?2345b78901234X67890c234567890X6789012345", 0 ;, "X67890"
	;SmPat7	db "X678901", 0
FoundPatternSubEcx:
	sub ecx, ebp
FoundPattern:						; we need to check the rest of the string here
	cmp edi, 0ffffffh			; 3 bytes = 5-byte pattern, OK
	jbe Match
	push esi
	push ebx
	lea ebx, [esi+ecx-16+4]			; Mainstring: 1 byte covered by inner loop, 4 by edi, so we check from byte 6 onwards
	mov esi, [esp+6*4+3*4+4+4]		; Pattern
	add ebx, ebp
	add esi, 5
@@:
	if UseLodsb
		lodsb			; sometimes a few cycles faster (but difficult to prove)
		test al, al		; this cannot be shifted below because of the rare case of equality after the zero delimiter:
		je @F			; db "Mainstr", 0, "abc" ... db "str", 0, "abx"  would crash
	else
		movzx eax, byte ptr [esi]		; esi=Substr (mov al is a few cycles slower)
		test eax, eax
		je @F
		inc esi
	endif
	inc ebx
	cmp al, [ebx]						; ebx=Mainstr
	je @B

@@:	pop ebx
	pop esi
	jne BadLuck						; test al, al not needed, flags still valid

Match:
	sub esi, [esp+6*4+2*4]			; lpSource: subtract original src pointer
	lea eax, [esi+ecx-15]				; and adjust for the index
	add eax, ebp						; ebp = offset in first unaligned chunk

NoMatch:
	pop edx								; 6 registers
	pop ecx
	pop ebp
	pop ebx
	pop edi
	pop esi
	;and tjj1, 0
	ret 4*4							; 4 arguments

;ByteScan:
;	imul eax, 01010101h			; propagate lobyte
;	movd xmm3, eax
;	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
;@@:	movdqu xmm1, [esi]			; load 16 bytes from current unaligned address
;	movdqa xmm2, xmm1			; save 16 bytes for testing the zero delimiter
;	lea esi, [esi+16]				; len counter (moving up/down lea or add costs cycles)
;	pcmpeqb xmm1, xmm3		; compare packed bytes in xmm1 and xmm3 (elephant) for equality
;	pcmpeqb xmm2, xmm1		; xmm1 is filled with either 0 or FF; if it's FF, the byte at that position cannot be zero
;	pmovmskb edx, xmm1		; set byte mask in edx for search pattern word
;	pmovmskb ecx, xmm2			; set byte mask (bits 0...15) in ecx for zero delimiter
;	test ecx, ecx					; zero byte found?
;	jnz @F							; check ebp, then ChkNull
;	test edx, edx					; pattern found?
;	jz @B							; 0=no pattern byte found, go back

;@@:	xor eax, eax					; default; no match
;	bsf edx, edx					; 34", 0, "X6
;	test ecx, ecx					; nullbyte found?
;	je @F
;	bsf ecx, ecx						; if yes, we need to check if
;	cmp ecx, edx					; it comes before or after the match
;	jb NoMatch

;@@:	lea eax, [esi+edx-15]
;	sub eax, [esp+6*4+2*4]
;	jmp NoMatch

InstrJJ endp
InstrJJe:

align 16
InstrJJo proc StartPos:DWORD, lpSource:DWORD, lpPattern:DWORD, sMode:DWORD
	push esi
	push edi
	push ebx					; all registers preserved, except eax = return value
	push ebp
	push ecx
	push edx
;	and tjj1, 0						; may be used for testing
;	and tjj2, 0
	mov esi, [esp+6*4+2*4]		; lpSource
	mov edx, [esp+6*4+3*4]		; lpPattern
	movzx eax, word ptr [edx]	; 3 cycles to fill xmm3 with first word
	test ah, ah
	je ByteScan
	imul eax, 00010001h			; propagate loword
	movd xmm3, eax
	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
	mov edi, [edx+2]				; next 4 bytes of pattern
	mov eax, edi
	or ebx, -1
	.if al==0
		xor ebx, ebx				; byte 3 is zero
		mov edi, ebx
	.elseif ah==0
		movzx ebx, bl				; byte 4 is zero
		and edi, ebx
	.else
		shr eax, 16
		.if al==0
			movzx ebx, bx		; byte 5 is zero (= and ebx, 0FFFFh)
		.elseif ah==0
			and ebx, 0ffffffh		; byte 6 is zero 
		.endif
	.endif
	and edi, ebx					; apply mask for bytes 2-5
;	movzx eax, word ptr [edx]	; 3 cycles to fill xmm3 with first word
;	imul eax, 00010001h			; propagate loword
;	movd xmm3, eax
;	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
	test esi, 15						; aligned?
	je L0							; if aligned, clear ebp and go directly into the main loop
	movups xmm1, [esi]			; load 16 bytes from current unaligned address
	movups xmm4, [esi+1]		; load another16 bytes
	mov ebp, esi					; save unaligned address
	and esi, -16						; align esi downwards
	jmp @F
;	REPEAT 5						; 5 nops = 20 cycles less?? 0: 3150  1:3142  2:3146  3:3148  4:3144  5: 3132/3151/3142/3155
;		nop
;	ENDM
L0:	xor ebp, ebp
L1:	movaps xmm1, [esi]			; load 16 bytes from current aligned address
	movups xmm4, [esi+1]		; load another 16 bytes
	; xor ebp, ebp					; zero the remainder in first aligned loop
@@:	movaps xmm2, xmm1			; save 16 bytes for testing the zero delimiter
	lea esi, [esi+16]				; len counter (moving up/down lea or add costs cycles)
	; inc tjj1
	; add esi, 16					; ca. 8 cycles slower on P4
	pcmpeqw xmm1, xmm3		; compare packed words in xmm1 and xmm3 (elephant) for equality
	pcmpeqb xmm2, xmm1		; xmm1 is filled with either 0 or FF; if it's FF, the byte at that position cannot be zero
	pcmpeqw xmm4, xmm3		; compare packed words in xmm4 and xmm3 (elephant) for equality
	pmovmskb edx, xmm1		; set byte mask in edx for search pattern word
	pmovmskb eax, xmm2		; set byte mask in eax for zero delimiter
	pmovmskb ecx, xmm4			; set byte mask in ecx for search pattern word
	shl ecx, 1						; adjust for esi+1 (add ecx, ecx is a lot slower)
	test eax, eax					; zero byte found?
	jnz @F							; check ebp, then ChkNull
	or edx, ecx						; one of them needs to have the word
	jz L1							; 0=no pattern byte found, go back

@@:	test ebp, ebp					; 0=never unaligned, or second loop
	je @F							; ebp=16*n+1....15 ->esi=16*n+16, i.e. esi>ebp
	add ebp, 16
	.if ebp<esi						; at least second loop
		xor ebp, ebp
	.endif
	and ebp, 15

@@:	test eax, eax
	jnz ChkNull

@@:	bsf ecx, edx						; bit scan for the index --------------------------
	lea eax, [esi+ecx-15]
	mov eax, [eax+ebp+1]			; first unaligned chunk contains match
	btr edx, ecx						; clear bit ecx in edx
	and eax, ebx
	cmp eax, edi
	je FoundPattern
BadLuck:
	xor ebp, ebp
	test edx, edx
	jnz @B						; bit scan end ------------------------------------------
	jmp L1						; 0=no more hits in these 16 bytes, go back searching (reversing order is somewhat slower)

ChkNull:
	mov ebx, eax				; position of zero byte
	xor eax, eax				; default: 0=no match
	or edx, ecx					; one of them needs to have the word
	je NoMatch
	bsf ebx, ebx				; nullbyte index in ebx
	bsf ecx, edx					; pattern word index in ecx
	cmp ebx, ecx				; null before pattern word: outta here
	jb NoMatch
	cmp [esi+ecx-14], edi		; what if edi==0???
	jne NoMatch				; first dword after first word doesn't match, so get out

FoundPattern:						; we need to check the complete string here
	test edi, edi					; one-word pattern?
	je Match
	push edi
	push esi
	mov edi, [esp+6*4+3*4+8]		; lpPattern
	lea esi, [esi+ecx-16]
	add esi, ebp

@@:	inc edi
	inc esi
	movzx eax, byte ptr [edi]
	test eax, eax
	je @F
	cmp al, byte ptr [esi]
	je @B

@@:	pop esi
	pop edi
	test eax, eax
	jne BadLuck
	; mov eax, tjj1	; test var 1
	; mov edx, tjj2	; test var 2
Match:
	sub esi, [esp+6*4+2*4]	; lpSource: subtract original src pointer
	lea eax, [esi+ecx-15]		; and adjust for the index
	add eax, ebp				; ebp = offset in first unaligned chunk

NoMatch:
	pop edx		; 6 registers
	pop ecx
	pop ebp
	pop ebx
	pop edi
	pop esi
	; dec eax
	ret 4*4		; 4 arguments

ByteScan:
	; int 3
	imul eax, 01010101h			; propagate lobyte
	movd xmm3, eax
	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
@@:	movups xmm1, [esi]			; load 16 bytes from current aligned address
	movaps xmm2, xmm1			; save 16 bytes for testing the zero delimiter
	lea esi, [esi+16]				; len counter (moving up/down lea or add costs cycles)
	pcmpeqb xmm1, xmm3		; compare packed bytes in xmm1 and xmm3 (elephant) for equality
	pcmpeqb xmm2, xmm1		; xmm1 is filled with either 0 or FF; if it's FF, the byte at that position cannot be zero
	pmovmskb edx, xmm1		; set byte mask in edx for search pattern word
	pmovmskb ecx, xmm2		; set byte mask in ecx for zero delimiter
	test ecx, ecx					; zero byte found?
	jnz @F							; check ebp, then ChkNull
	test edx, edx					; pattern found?
	jz @B							; 0=no pattern byte found, go back

@@:	xor eax, eax
	bsf ecx, ecx
	bsf edx, edx
	cmp ecx, edx
	ja NoMatch
	lea eax, [esi+edx-15]
	sub eax, [esp+6*4+2*4]
	jmp NoMatch

InstrJJo endp
InstrJJoe:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

align 16
InstrSse2D proc uses edi esi ebx StartPos:DWORD, lpSource:DWORD, lpPattern:DWORD, sMode:DWORD
	push ecx					; all registers preserved, except eax = return value
	push edx
	mov eax, lpPattern
	mov edi, [eax+1]			; next 4 bytes of pattern
	movzx eax, byte ptr [eax]
	imul eax, 01010101h		; propagate the first byte
	movd xmm3, eax
	pshufd xmm3, xmm3, 0
	mov eax, lpSource

L1:
	movaps xmm1, [eax+16]
	movaps xmm2, xmm1			; save 16 bytes for testing the zero delimiter
	pcmpeqb xmm1, xmm3		; compare packed bytes in xmm1 and xmm3 (elephant) for equality
	pcmpeqb xmm2, xmm1		; xmm1 has either 0 or FF
	movaps xmm0, [eax]			; load earlier bytes (faster) 
	movaps xmm4, xmm0			; save 16 bytes for testing the zero delimiter
	pcmpeqb xmm0, xmm3		; compare packed bytes in xmm2 and xmm3 (elephant) for equality
	pcmpeqb xmm4, xmm0		; xmm0 has either 0 or FF
	lea eax, [eax+32]				; len counter (moving up/down lea or add costs cycles)
	por xmm1, xmm0				; or them: one of the mem locations may contain a nulldword
	por xmm4, xmm2				; or them: one of the mem locations may contain a nulldword
	pmovmskb ecx, xmm4			; set byte mask in ecx for zero delimiter
	pmovmskb edx, xmm1		; set byte mask in edx for search pattern byte
	test ecx, ecx
	jnz ChkNull
	test edx, edx
	jz L1

	shl edx, 16					; create space for the ecx bytes
	pmovmskb ecx, xmm0		; set byte mask in ecx (has to be repeated, sorry)
	or edx, ecx					; combine xmm0 and xmm1 results

	; int 3

@@:	bsf ecx, edx				; bit scan for the index
	je L1					; 0=no more hits in first 16 bytes, go back searching
	cmp [ecx+eax-31], edi
	je FoundPattern
	btr edx, ecx					; clear that bit
	jmp @B

ChkNull:
	cmp ecx, edx				; null before pattern byte: outta here
	jb @F
	cmp [ecx+eax-31], edi
	je FoundPattern

@@:	xor eax, eax
	jmp NoMatch

FoundPattern:
	sub eax, lpSource			; subtract original src pointer
	lea eax, [ecx+eax-31]
NoMatch:
	pop edx
	pop ecx
	ret
InstrSse2D endp
InstrSse2De:

align 16

InstrCi proc uses edi esi ebx StartPos:DWORD, lpSource:DWORD, lpPattern:DWORD, sMode:DWORD
  mov eax, lpSource		; e.g. invoke InstrCi, 1, addr Mainstr, addr SubstrxCi, 0 means
  mov ecx, StartPos		; start at pos1, find Substr in Mainstr, case-sensitive
  dec ecx					; 1-based index, so if 1 is passed, add nothing to eax
  .if Sign?
	mov ecx, CurPos	; invoke InstrCi, 0, ... means continue with Current Position
  .endif
  add eax, ecx				; start with current position or StartPos
  xor ebx, ebx				; default mode: case-sensitive search
  mov ecx, sMode
  .if ecx
	add ebx, 20h		; intellicase: finds "test" and "Test" but not "TEST" in "This is a Test"
	dec ecx
	.if Zero?			; sMode==1: lowercase bit mask for finding "TEST" in "This is a Test"
		mov ebx, 20202020h
	.endif
  .endif

NoSucc:	mov edx, lpPattern	; address of pattern
		mov cl, [edx+1]
		test cl, cl
		je FindOneByte		; eax is startpos in lpSource
		mov edx, [edx]		; edx has 4 bytes of pattern, e.g. test
		or edx, ebx			; make first byte or first 4 bytes of pattern lowercase, if sMode is set
@@:
	REPEAT 3
	movzx ecx, word ptr [eax]	; take a word from the source string
	test cl, cl		; source end?
	jz SrcEnd
	add eax, 1		; these 3 are innermost loops, and inc eax would cost 2-3%
	or ecx, ebx		; make source lowercase
	cmp cx, dx		; compare 2 bytes of source with pattern
	je @F
	ENDM

	movzx ecx, word ptr [eax]	; take a word from the source string
	test cl, cl		; source end?
	jz SrcEnd
	add eax, 1		; this is the last innermost loop, and inc eax would cost 2-3%
	or ecx, ebx		; make source lowercase
	cmp cx, dx		; compare 2 bytes of source with pattern
	jne @B

@@:	mov esi, lpPattern
	mov edi, eax	; current pos in source string
	inc esi			; inc changes flags
	push eax		; save current pos

@@:	mov al, [esi]	; movzx eax, byte ptr [esi]
	inc esi			; add esi, 1 is faster but here it doesn't matter
	test al, al		; pattern end?
	jz @F
	or al, bh		; make lowercase; mode 0,2: bh=0, mode 1: bh=20h
	mov cl, [edi]
	or cl, bh			; make lowercase; mode 0,2: bh=0, mode 1: bh=20h
	inc edi			; add edi, 1 is faster but here it doesn't matter
	cmp al, cl		; if equal, go for the next char
	je @B

@@:	pop eax			; current pos in source string restored
	mov ecx, [esi-1]	; check for end of pattern - if yes, we are done
	or cl, cl			; get the flag
	jz @F			; if not zero, we still have to test a...
	mov ecx, [esi-2]		; ... rare case: pattern and source finish on the same byte
	or cl, cl
	jnz NoSucc

@@:	mov ecx, eax		; SUCCESS!
	sub ecx, lpSource	; ecx has the relative pos, if needed
	mov CurPos, ecx	
	dec eax				; we return in eax the pos in lpSource where the pattern was found
	jmp @F

SrcEnd:
	xor eax, eax		; no match found, sorry
	xor ecx, ecx
@@:
	ret

FindOneByte:
	mov edi, eax	; rep scasb
	push edx		; save lpSource
	mov ecx, len(edi)
	pop edx			; lpSource
	mov al, [edx]	; the byte
	repne scasb	; avanti!
	cmp al, [edi-1]
	jne SrcEnd		; no match
	mov ecx, edi
	sub ecx, lpSource
	mov eax, edi
	jmp @B

InstrCi endp
RetInstrCi:

; ##############################################

align 16	; [url=http://www.masm32.com/board/index.php?topic=4602.msg34249#msg34249]Hutch[/url]

BM proc startpos:DWORD,lpSource:DWORD,srcLngth:DWORD,
                       lpSubStr:DWORD,subLngth:DWORD

  ; -----------------------------------------------------------------
  ; This version uses four heuristics, it determines the shift type
  ; from the character in the table, if the character is not in the
  ; pattern, it performs a BAD CHARACTER shift, if the character is
  ; in the pattern, it determines if it is the first comparison after
  ; the shift and adds the GOOD SUFFIX shift to the location counter.
  ; If the comparison is not the first after the shift, it calculates
  ; the GOOD SUFFIX shift and adds it to the location counter.
  ; -----------------------------------------------------------------

    LOCAL cval   :DWORD
    LOCAL shift_table[256]:DWORD

    push ebx
    push esi
    push edi

    mov ebx, subLngth

    cmp ebx, 1
    jg @F
    mov eax, -2                 ; string too short, must be > 1
    jmp Cleanup
  @@:

    mov esi, lpSource
    add esi, srcLngth
    sub esi, ebx
    mov edx, esi            ; set Exit Length

  ; ----------------------------------------
  ; load shift table with value in subLngth
  ; ----------------------------------------
    mov ecx, 256
    mov eax, ebx
    lea edi, shift_table
    rep stosd

  ; ----------------------------------------------
  ; load decending count values into shift table
  ; ----------------------------------------------
    mov ecx, ebx                ; SubString length in ECX
    dec ecx                     ; correct for zero based index
    mov esi, lpSubStr           ; address of SubString in ESI
    lea edi, shift_table

    xor eax, eax

  Write_Shift_Chars:
    mov al, [esi]               ; get the character
    inc esi
    mov [edi+eax*4], ecx        ; write shift for each character
    dec ecx                     ; to ascii location in table
    jnz Write_Shift_Chars

  ; -----------------------------
  ; set up for main compare loop
  ; -----------------------------
    mov ecx, ebx
    dec ecx
    mov cval, ecx

    mov esi, lpSource
    mov edi, lpSubStr
    add esi, startpos           ; add starting position

    jmp Pre_Loop

; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Calc_Suffix_Shift:
    add eax, ecx
    sub eax, cval               ; sub loop count
    jns Add_Suffix_Shift
    mov eax, 1                  ; minimum shift is 1

  Add_Suffix_Shift:
    add esi, eax                ; add SUFFIX shift
    mov ecx, cval               ; reset counter in compare loop

  Test_Length:
    cmp edx, esi                ; test exit condition
    jl No_Match

  Pre_Loop:
    movzx eax, BYTE PTR [esi+ecx]
    cmp al, [edi+ecx]           ; cmp characters in ESI / EDI
    je @F
    mov eax, shift_table[eax*4]
    cmp ebx, eax
    jne Add_Suffix_Shift        ; bypass SUFFIX calculations
    add esi, ecx
    add esi, 1
    jmp Test_Length
  @@:
    sub ecx, 1

  Cmp_Loop:
    movzx eax, BYTE PTR [esi+ecx]
    cmp al, [edi+ecx]           ; cmp characters in ESI / EDI
    jne Set_Shift               ; if not equal, get next shift
    sub ecx, 1
    jns Cmp_Loop
    jmp Match                   ; fall through on match

  Set_Shift:
    mov eax, shift_table[eax*4]
    cmp ebx, eax
    jne Calc_Suffix_Shift       ; run SUFFIX calculations
    add esi, ecx
    add esi, 1
    jmp Test_Length

; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Match:
    sub esi, lpSource           ; sub source from ESI
    mov eax, esi                ; put length in eax
    jmp Cleanup

  No_Match:
    mov eax, -1

  Cleanup:
    pop edi
    pop esi
    pop ebx

    ret

BM endp
BMe:

OPTION		PROLOGUE:NONE			; TURN IT OFF
OPTION		EPILOGUE:NONE							
align 			16
db			6  Dup(9)						; Lingo's magic fill bytes cost a few cycles ;-)
BMLinDB		proc	lpBuffer:dword, lpSrchPatt:dword, lenSrchPatt:dword
	pop edx		; return address
	movd MM2, edi
	pop eax		; eax->lpBuffer		; ecx->lenSrchPattern
	movd MM3, esi
	pop esi		; esi->lpSrchPatt
	movd MM4, ebx
	pop ecx		; ecx->lenSrchPattern		; must be greater than 8!!!
;	push eax
;	mov ecx, len(esi)	; suggestion by jj ;-)
;	pop eax
	movd MM5, ebp
	lea ebp, [ecx+1]		; ebp->lenSrchPatt +1
	movd MM1, esp
	mov ebx, [esi]		; ebx->first dword of the SrchPattern
	mov edi, esi
	movd xmm0, ebp
	mov esp, eax
	punpcklbw xmm0, xmm0
	punpcklbw xmm0, xmm0
	pshufd xmm0, xmm0, 0
	mov ebp, [esi+ecx-4]		; ebp->last dword of the Search Pattern
	mov edx, ecx
	movdqa oword ptr [tabl+ 0*16], xmm0		; xmm0= lenSrchPattern +1
	movdqa oword ptr [tabl+ 1*16], xmm0
	movdqa oword ptr [tabl+ 2*16], xmm0
	movdqa oword ptr [tabl+ 3*16], xmm0
	movdqa oword ptr [tabl+ 4*16], xmm0
	movdqa oword ptr [tabl+ 5*16], xmm0
	movdqa oword ptr [tabl+ 6*16], xmm0
	movdqa oword ptr [tabl+ 7*16], xmm0
	movdqa oword ptr [tabl+ 8*16], xmm0
	movdqa oword ptr [tabl+ 9*16], xmm0
	movdqa oword ptr [tabl+10*16], xmm0
	movdqa oword ptr [tabl+11*16], xmm0
	movdqa oword ptr [tabl+12*16], xmm0
	movdqa oword ptr [tabl+13*16], xmm0
	movdqa oword ptr [tabl+14*16], xmm0
	movdqa oword ptr [tabl+15*16], xmm0
@@:
	movzx eax, byte ptr [edi]
	add edi, 1
	mov byte ptr [tabl+eax], cl
	sub ecx, 1
	jne @b

	movzx eax, byte ptr [esp+edx]
	pop ecx
	movzx eax, byte ptr [tabl+eax]
	cmp ecx, ebx
	je @LastDwdb

BM_LoopDB:
	lea esp, [esp+eax-4]
	je @f
@@:
	movzx eax, byte ptr [esp+edx]
	pop ecx
	movzx eax, byte ptr [tabl+eax]
	cmp ecx, ebx
	je @LastDwdb
	lea esp, [esp+eax-4]
	jne @b
@LastDwdb:
	cmp ebp, [esp+edx-8]
	jne BM_LoopDB
	mov edi, [edx+esi-8]
	db 2Eh		; cs:
	lea ecx, [edx-8]
	cmp [ecx+esp-4], edi
	jne BM_LoopDB
@@:
	add ecx, -4
	jle @f
	mov edi, [ecx+esp-4]
	cmp edi, [ecx+esi]
	jne BM_LoopDB
	add ecx, -4
	jle @f
	mov edi, [ecx+esp-4]
	cmp edi, [ecx+esi]
	jne BM_LoopDB
	add ecx, -4
	jle @f
	mov edi, [ecx+esp-4]
	cmp edi, [ecx+esi]
	jne BM_LoopDB
	add ecx, -4
	jle @f
	mov edi, [ecx+esp-4]
	cmp edi, [ecx+esi]
	jne BM_LoopDB
	add ecx, -4
	jle @f
	mov edi, [ecx+esp-4]
	cmp edi, [ecx+esi]
	jne BM_LoopDB
	add ecx, -4
	jle @f
	mov edi, [ecx+esp-4]
	cmp edi, [ecx+esi]
	jne BM_LoopDB
	je @b
align 16
@@:
	cmp esp, esi		; esi-> address of the SrchPattern(after end of the buffer)
	lea ecx, [esp-4]		; esp-> current offset in the buffer
	sbb eax, eax
	movd esp, MM1		; restore registers
	movd edi, MM2
	movd esi, MM3
	movd ebx, MM4
	movd ebp, MM5
	sub ecx, [esp-3*4]		; [esp-3*4] -> lpBuffer
	and eax, ecx		; eax= offset in the buffer or zero
	jmp dword ptr [esp-4*4]		; jmp to return address
BMLinDB endp
BMLinDBe:

OPTION PROLOGUE:prologuedef
OPTION EPILOGUE:epiloguedef
InStringTheSvin proc uses ebx esi edi startpos:DWORD,lpSource:DWORD,lpPattern:DWORD
  ; ------------------------------------------------------------------
  ; InString searches for a substring in a larger string and if it is
  ; found, it returns its position in eax.   ;
  ; It uses a one (1) based character index (1st character is 1,
  ; 2nd is 2 etc...) for both the "StartPos" parameter and the returned
  ; character position.  ;  ; Return Values.
  ; If the function succeeds, it returns the 1 based index of the start
  ; of the substring.  ;  0 = no match found
  ; -1 = substring same length or longer than main string
  ; -2 = "StartPos" parameter out of range (less than 1 or longer than
  ; main string)
  ; ------------------------------------------------------------------
    LOCAL pLen:DWORD
    push ebx
    push esi
    push edi

    mov esi, lpSource
    mov edi, lpPattern

    invoke StrLen,esi
    mov ebx, eax           ; ebx = source length
    invoke StrLen,edi
    mov ecx,startpos       ;ecx = startpos
    add edi,eax            ;edi=end of pattern
    neg eax                ;edi+eax = start of pattern
    mov pLen, eax           ; - (pattern length)
    dec ecx        ;ecx = startpos -1
    js @errm2                  ;startpos <= 0? yes - goto error -2
    add ebx,eax        ;ebx= sLen - pLen
    js @errm1          ; if sLen < pLen goto error -1
    lea esi,[esi][ebx][1]    ; esi= address of part wich is < pLen
    not ebx        ;ebx = -(ebx+1)= - ((sLen - pLen)+1)
    add ecx,ebx        ; ecx = startpos -1 ebx = - ((sLen - pLen)+1)               ;if ecx >=  (sLen - pLen)+1 then
    jns @errm2         ;ecx - ((sLen-pLen)+1) >= 0 and SF =0
    mov al,[edi][eax]  ;first byte
    jmp Loop_Start
;@@@@@@@@@

Pre_Loop:
   pop ecx      ;restore ECX
   inc  ecx     ;start on next byte
Loop_Start:
   cmp al,[esi+ecx]
   je Pre_Sub
   inc ecx
   jnz Loop_Start
   xor eax,eax
   jmp isOut
Pre_Sub:
   push ecx ;preserve ECX
   mov edx,pLen
Sub_Loop:
   inc ecx
   inc edx ;don't check fist byte
   mov ah,[esi+ecx]
   je found ;edi+0 = pattern end
   cmp ah,[edi][edx]
   je Sub_Loop
   jmp Pre_Loop

; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
found:
    pop eax
    sub eax, ebx ;sub neg value = add positive
    inc eax

  isOut:
    pop edi
    pop esi
    pop ebx
    ret
@errm2:
   mov eax,-2
   jmp isOut
@errm1:
   mov eax,-1
   jmp isOut
InStringTheSvin endp
InStringTheSvine:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
ShowCpu proc mode:DWORD
COMMENT	@ Usage: 
Move this line up:
ShowCpu	PROTO:DWORD

	invoke ShowCpu, 0		; simple, no printing, just returns SSE level
	invoke ShowCpu, 1		; prints the brand string and returns SSE level@
  pushad
  sub esp, 80		; create a buffer for the brand string
  mov edi, esp		; point edi to it
  ; push edi
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp
ShowCpue:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

end start
OPT_Tmp2Asm	1
OPT_Wait	0	; inkey
OPT_Assembler	ml

P4 timings:
Intel(R) Pentium(R) 4 CPU 3.40GHz (SSE3)

12870   CRT_strstr, addr Mainstr, addr TestSubE
11416   CRT_strstr, addr Mainstr, addr TestSubD
21140   CRT_strstr, addr Mainstr, addr TestSubX

Average cycle count:
5035     InstrJJ (jj2007)
4097     BMLinDB (Lingo)
16176    MasmLib InstringL
InstrJJ : InstringL = 31 %
Code size InstrJJ=366

Celeron M timings (10.05.2009):
Average cycle counts:
2475     InstrJJ (jj2007)
2991     BMLinDB (Lingo)
6717     BM (Boyer-Moore Hutch)
10115    InString (Masm32 Lib)
InstrJJ : InString = 24 %

Code sizes:
InstrJJ=	388
BM=	199
BMLinDB=	395
InStringL=	305
[quote author=dedndave link=topic=9370.msg84552#msg84552 date=1241736967]
what makes it faster ?

(where's the beef?)
[/quote]

Here is the inner loop (simplified):

[code]L1:	movdqa xmm1, [esi]	; load 16 bytes from current aligned address
	movdqu xmm4, [esi+1]	; load another 16 bytes UNALIGNED - must be in the middle
	movdqa xmm2, [esi]	; save 16 bytes for testing the zero delimiter - faster than movdqa xmm2, xmm1
Lu:	lea esi, [esi+16]	; position in mainstring (moving up/down lea or add costs cycles)
	pcmpeqw xmm1, xmm3	; compare packed words in xmm1 and xmm3 for equality
	pcmpeqw xmm4, xmm3	; compare packed words in xmm4 and xmm3 for equality
	pcmpeqb xmm2, xmm1	; xmm1 is filled with either 0 or FF; if it's FF, the byte at that position cannot be zero
	pmovmskb eax, xmm2	; set byte mask in ecx for zero delimiter
	pmovmskb edx, xmm1	; set byte mask in edx for search pattern word
	pmovmskb ecx, xmm4	; set byte mask in ecx for search pattern word
	shl ecx, 1		; adjust for esi+1 (add ecx, ecx is a lot slower)
	test eax, eax		; zero byte found?
	jnz @F			; check/clear ebp, then ChkNull
	or edx, ecx		; one of them needs to have the word
	je L1			; 0=no pattern byte found, go back
[/code]

The secret is in [b]pcmpeqw[/b]:
[url=http://www.intel.com/software/products/documentation/vlin/mergedprojects/analyzer_ec/mergedProjects/reference_olh/mergedProjects/instructions/instruct32_hh/vc231.htm]Compare packed words in xmm2/m128 and xmm1 for equality[/url]

The SSE2 loop is very fast, much faster than all the rest, because it reads 16 bytes at a time. The art is [i]not to leave it[/i] too often.
Traditional Instring implementations have a byte scanner as the inner loop: Take the first character of your search pattern, e.g. [b]d[/b] for dedndave,
and loop until you find it; then check the rest, if it's [b]edndave[/b], great, otherwise back to the inner loop.
You can imagine that you have to leave the inner loop very often for e, n, s etc. - and that your fast inner loop gets slowed down drastically.

Now the trick here is to use a [b]word [/b]scanner: [b]de[/b] is a lot less frequent that a single [b]d[/b] - statistically speaking 256 times less frequent.
The inner loop is a little bit slower, because you need some acrobatics (and one slow unaligned movedqu) to implement a word scanner, but it pays off in general.
The only algo that comes close is [url=http://www.masm32.com/board/index.php?topic=3601.msg83512#msg83512]Lingo's Boyer-Moore implementation[/url]
(and it is even faster on a P4).