; INSTR replacement string searcher routines test

TimesToLoop	equ 10000
TimesToLoop2	equ 50
PatternInfo =	1
OptiStrings =	1

; procs to test
Procs textequ <OVH,InStrL,InstrM32,finstr,finstr2,finstr3,finstr4,finstr5,finstr6,InstrJJ,InstrJJw>	; include OVH to check that overhead is being properly removed from timing
;Procs textequ <InStrL,finstr>

; strings to test.  Source/Pattern, Source2/Pattern2, etc.
; Tests TEXTEQU <Mainstr/Substr1,Mainstr/Substr2, Mainstr/Substr3, Mainstr/Substr4, mismatch/mmStr_x>

if 1
  Tests TEXTEQU <Mainstr/Substr1,Mainstr/Substr2, Mainstr/Substr4, mismatch/mmStr_b, mismatch/mmStr_x, fbuffer/WindInc>
  TestType Textequ <Short,Medium,HighAnsi,MisMatch,MisMatch,File,Overall>
else
  Tests TEXTEQU <Mainstr/Substr1,Mainstr/Substr2, Mainstr/Substr3, Mainstr/Substr4, mismatch/mmStr_b, mismatch/mmStr_x, fbuffer/WindInc>
  TestType Textequ <Short,Medium,Long,HighAnsi,MisMatch,MisMatch,File,Overall>
endif
PriClass textequ <REALTIME_PRIORITY_CLASS> ; priority to use for tests
;PriClass textequ <NORMAL_PRIORITY_CLASS>	; for debugging
    
.686p
.xmm
.model	flat, stdcall
option	casemap :none   ; case sensitive
.nolist

include \masm32\include\windows.inc
include \masm32\macros\macros.asm

    ; InstrJJ	PROTO :DWORD, :DWORD, :DWORD, :DWORD
    ; InstrJJ	PROTO :DWORD, :DWORD
    ; InstrJJw	PROTO :DWORD, :DWORD
    ; InstrM32	PROTO :DWORD, :DWORD
    ShowCpu	PROTO:DWORD

uselib	MACRO	libname
	include		\masm32\include\libname.inc
	includelib	\masm32\lib\libname.lib
ENDM

uselib user32
uselib kernel32
uselib comctl32
uselib gdi32
uselib shell32
uselib comdlg32
uselib masm32
uselib debug
uselib msvcrt	; for getkey

inv equ Invoke

soff Macro QuotedText:Vararg	; returns offset to a string
Local LocalText
.data
LocalText db QuotedText,0
.code
EXITM <offset LocalText>
Endm
.listall

.data?
align 16
StartingCycle	dd ?
CyclePart2	dd ?
Loops	dd ?
ExtraLoops	dd ?
Min	dd ?
OverHead	dd ?	; overhead of doing an empty proc
TotalCycles	dd ?
TotalCt	dd ?
AuxAdd	dd ?	; for InstrM32
fbuffer	dd ?	; for the Windows.inc test
flen	dd ?

.code
BeginCounter macro	; This macro is inserted before a block of test code
	align 16	; just to be sure all code starts with equal advantage
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, PriClass	; use the highest priority for all the tests
	invoke GetCurrentThread
	inv SetThreadPriority,eax,THREAD_PRIORITY_TIME_CRITICAL
            
	mov Min,9999999999
	mov Loops,TimesToLoop
	mov eax, T1Offset
	.if eax==fbuffer
		mov Loops,TimesToLoop2
	.endif
	
	mov ExtraLoops,10	; will do several times first to let things settle out
    inv Sleep,0
ExtraLoopsLoop = $
	sub ExtraLoops,1
TimingLoop = $
	mov	[StartingCycle],eax		; just to make sure they are in the cache
	mov	[StartingCycle+4],eax
	Repeat 6	; Intel says 4 but I've found that more works a little better
	xor eax,eax
	cpuid 		; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
	Endm
	rdtsc
	mov	[StartingCycle],eax
	mov	[StartingCycle+4],edx
endm
EndCounter macro		; This macro is inserted after each block of test code
	xor eax,eax
	cpuid		; flush
	rdtsc
	cmp ExtraLoops,0
	jne ExtraLoopsLoop	; skip first several iterations
	sub eax,[StartingCycle]	; get result in EDX:EAX
	sbb edx,[StartingCycle+4]
	cmp Min,eax
	jb @f
	mov Min,eax
@@:
	sub Loops,1
	jnz TimingLoop
	invoke GetCurrentThread
	inv SetThreadPriority,eax,THREAD_PRIORITY_NORMAL
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, NORMAL_PRIORITY_CLASS	; back to normal
    inv Sleep,0 
	mov eax,Min		; return the minimum elapsed time
	.if DoingOverhead==0
		sub eax,OverHead
	.endif
endm
;----------------------------  SETUP --------------------------------------
.data			; data for tests

WindInc	db "Duplicate inc", 0	; favours word scanner
; WindInc	db "xtra.inc", 0		; favours byte scanner
; WindInc	db "WARNING Duplicate include file windows.inc", 0	; favours byte scanner

align 16
  if OptiStrings
    ; Mainstr db "The time has come the walrus said to speak of ceiling wax, and the sea is boiling hot...   ",0
    Mainstr db "The time walrus ceiling sea is boiling hot... has come the said to speak of wax, and the   ",0

    Substr1  db " wal",0
    Substr2  db "ceiling",0
    Substr3  db "sea is boiling",0
    Substr4  db "",0

align 4
mismatch	db "billabone billabone billabone billabone billabone billabone billabone billabone billabone billabone ", 0

align 4
    mmStr_b   db "billa", 0		; frequent first character
    mmStr_x   db "xilla", 0		; favours byte scanner
  else
    Mainstr db "The time has come the walrus said to speak of many things,"
            db " of birds and bugs and ceiling wax, of cabbages and kings."
            db " And if the sea is boiling hot and whether pigs have wings  ",0

    Substr1  db " walrus ",0
    Substr2  db "ceiling wax",0
    Substr3  db "sea is boiling hot",0
    Substr4  db "",0

align 4
mismatch	db "billabone billabone billabone billabone billabone billabone billabone billabone billabone billabone "
	db "billabone billabone billabone billabone billabone billabone billabone billabone billabone billabone "
	db "billabone billabone billabone billabone billabone billabone billabone billabone billabong ",0
align 4
    mmStr_b   db "billabong", 0		; frequent first character
    mmStr_x   db "xillabong", 0		; favours byte scanner
  endif

    cl1 dd 0
    cl2 dd 0
    cl3 dd 0

    .data?			; data for finstr routines
      align 16
      _ebx dd ?
      _esi dd ?
      _edi dd ?
      _ebp dd ?
      _esp dd ?

.code

    MAXWIDTH  equ 20
    HDRWIDTH  equ 8   ; leftmost header column
    COLWIDTH  equ 9

    %FOR proc,<Procs>	; ******  the calls to all procs must be the same for valid comparisons
        proc proto :dword,:dword ;,:dword,:dword,:dword,:dword,:dword
    ENDM

	MaxStr=0
	scount=0
	%For T1T2,<Tests>	; get maximum string size
		local T1,T2,sep
	    sep instr 1,<T1T2>,</>
	    T1 substr <T1T2>,1,sep-1    ; len of string 1
	    if sizeof T1 GT MaxStr
	    	MaxStr= sizeof T1
	    endif
	    T2 substr <T1T2>,sep+1      ; len of string 2
	    if sizeof T2 GT MaxStr
	    	MaxStr=sizeof T2
	    endif
	    scount=scount+2
	ENDM

.data
align 16
String1 db MaxStr*2+64 dup (0)      ; what will be input string1 to routines.  The extra 64 bytes are to represent
align 16                            ;   a possible next string in the real world that we would not want wiped out.
String2 db MaxStr+32   dup (0)      ; what will be input string2 to routines    

align 16
Str1Offset      dd  0   ; offset to starting byte within String1 based upon number of extra bytes being tested
Str2Offset      dd  0   ; offset to starting byte within String2 based upon number of extra bytes being tested
Junk		    dd  0   ; scrath place for mem protect	
.code
align 16

;Printing routines from Phil
sxFld proc DDpointer:DWORD, rvstring:DWORD, DDwidth:DWORD, DDalign:DWORD    
    .if DDalign == 0                    ; align left?
        invoke szLeft,DDpointer,rvstring,DDwidth
        invoke szLen,rvstring
        mov edx,rvstring
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+eax],32	;space
        inc eax
        jmp @B
    @@: mov byte ptr [edx+eax],0
    .elseif DDalign == 1                ; align right?
        invoke szLen,DDpointer
        mov edx,rvstring
        xor ecx,ecx
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+ecx],32
        inc eax
        inc ecx
        jmp @B
    @@: add edx,ecx
        invoke szLeft,DDpointer,edx,DDwidth
    .endif
    ret 4*4
sxFld endp

fld$ MACRO DDpointer,DDwidth,DDalign:=<0>       ; Default is align left
    LOCAL rvstring
    .data
        rvstring db MAXWIDTH+4 dup (0)
        align 16
    .code
    invoke sxFld,reparg(DDpointer),ADDR rvstring,DDwidth,DDalign
    EXITM <ADDR rvstring>
ENDM


;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------

.data
 DoingOverhead dd 0
.code

align 16

start:

	invoke ShowCpu, 1						; ***** show which CPU you are running ****
	mov AuxAdd, InString

	invoke read_disk_file, chr$("\masm32\include\windows.inc"), offset fbuffer, offset flen
	if 0
	.if eax
			LOOP_COUNT = 500
			print chr$(13, 10, "Find 'Duplicate inc' in Windows.inc (kCycles):", 13, 10)
			timings InstrJJ, 1, fbuffer, offset WindInc, 0
			timings BMLinDB, fbuffer, offset WindInc, (SIZEOF WindInc)-1
			timings InString, 1, fbuffer, offset WindInc
	 		print chr$(13, 10)
			LOOP_COUNT = CountSlow
	.else
		print chr$(13, 10, "reading windows.inc failed")
	.endif
	endif

	pcount=1
	%for proc,<Procs>	; count number of routines to test
		pcount=pcount+1
	endm
.data
	align 4
	ptable dd pcount dup (0)	; table of proc addresses
	lastproc dd 0				; address of last proc
	pname dd pcount dup (0)		; table of addresses of proc names for printing
.code
	mov edx,offset ptable	; address to call
	mov ecx,offset pname	; address of ascii name of routines for printing
	%for proc,<Procs>
		mov eax,offset proc
		mov [edx],eax		; save address of proc to call
		mov lastproc,edx	; save ending condition for loops
		add edx,4
		ifndef &proc&name
.data
			&proc&name db "&proc&",0	; save the proc names for headers
.code
		endif
		mov [ecx],offset &proc&name		; save the address of the proc name for headers
		add ecx,4
	endm

.data
	T1T2s dd scount dup (0)		; offsets of the test strings
	lastT1T2 dd 0  				; address of last T1T2 to use
.code
	mov edx,offset T1T2s
	%FOR T1T2,<Tests>
		local T1,T2,sep
	    sep instr 1,<T1T2>,</>
	    T1 substr <T1T2>,1,sep-1 	; Source
	    T2 substr <T1T2>,sep+1      ; Pattern
	    ifdif T1, <fbuffer>
		    mov eax,offset T1
	    else
		    mov eax, fbuffer			; the windows.inc file test needs the buffer itself, not the offset
		    ; would also require lower TimesToLoop...
	    endif
    	    mov [edx],eax
	    mov eax,Offset T2
	    mov [edx+4],eax
	    mov lastT1T2,edx
	    add edx,8
	ENDM

	; Now move the actual code to test to a common postion so all tests have the same advantage
	mov ecx,MaximumProcSize
	mov edx,offset TheProc
    inv VirtualProtect,edx,ecx,PAGE_EXECUTE_READWRITE,addr Junk	; stupid invoke
    invoke GetCurrentProcess
    mov edx,MaximumProcSize
    mov ecx,offset TheProc
    invoke FlushInstructionCache,eax,ecx,edx	; ditto
 
;   print out the headers
	
    print fld$(chr$("Type"),HDRWIDTH)
    %FOR T1T2,<TestType>
        print fld$(chr$("&T1T2&"),COLWIDTH,1)
    ENDM
    print chr$(13,10)

    print fld$(chr$("Source"),HDRWIDTH)
    mov ebx,offset T1T2s
    %FOR T1T2,<Tests>
        local sep
        sep instr 1,<T1T2>,</>
        print fld$(left$(chr$("&T1T2&"),sep-1),COLWIDTH,1)
    ENDM
        print fld$("  sum of",COLWIDTH)
    print chr$(13,10)
    print fld$(chr$("Pattern"),HDRWIDTH)
    if 0
    print chr$(13,10)
    print fld$(chr$("Src len"),HDRWIDTH)
    print chr$(13,10)
    print fld$(chr$("Pat len"),HDRWIDTH)
    endif
    %FOR T1T2,<Tests>
        local T1,T2,sep
        sep instr 1,<T1T2>,</>
        T1 substr <T1T2>,1,sep-1    ; Source
        T2 substr <T1T2>,sep+1      ; Pattern
        print fld$( remove$( chr$("&T1T2&"),left$(chr$("&T1T2&"),sep)),COLWIDTH,1)
    ENDM
        print fld$("  cycles*",COLWIDTH)
    print chr$(13,10)

    print fld$(chr$("====================="),HDRWIDTH)
    %FOR T1T2,<Tests>
        print fld$(" =====================",COLWIDTH)
    ENDM
        print fld$(" =====================",COLWIDTH)
    print chr$(13,10)


.data?
	PAddr      dd ?	; address of proc to call
	PTblPtr    dd ?	; address of proc within table
	PNamePtr   dd ? ; address of proc name within table
	TPtr       dd ?	; address of offset to test strings in table T1T2s
	T1Offset   dd ? ; offset of string 1 (string to search)
	T2Offset   dd ? ; offset of string 2 (patter to search for)
.code	
        ;%FOR proc,<Procs>
        mov PTblPtr,offset ptable	; initialize loop
        mov PNamePtr,offset pname
        procsloop:
            mov eax,PTblPtr	; get address of routine to test
            mov eax,[eax]
            mov PAddr,eax
            mov eax,PNamePtr
            mov eax,[eax]
            mov ecx,[eax]
            cmp ecx,0048564fh	; "OVH"  check for overhead proc
	        jne @f
	        mov DoingOverhead,1
	@@:
            print fld$(eax,HDRWIDTH)
            ; now move the proc to a standard location
           mov esi,PAddr
           mov ecx,MaximumProcSize
           mov edi,offset TheProc
	 and TotalCycles, 0
	 and TotalCt, 0
           rep movsb
           cpuid
;           %FOR T1T2,<Tests>
          	mov TPtr,offset T1T2s	; initialize loop
          	T1T2loop: 
                mov ecx,TPtr				; get offset of string 1
                mov eax,[ecx]
                mov T1Offset,eax
                mov eax,[ecx+4]				; get length of string 2
                mov T2Offset,eax

                BeginCounter
		push T2Offset
		push T1Offset
		call TheProc
                EndCounter
                cmp DoingOverhead,1
                jne @f
                mov OverHead,eax
                mov DoingOverhead,0
@@:
                mov ebx,eax
                inc TotalCt
                .if TotalCt!=6
	                add TotalCycles, ebx
	      .endif
                print fld$(sstr$(ebx),COLWIDTH,1)
                
            ;ENDM
            add TPtr,8
            mov eax,TPtr
            cmp eax,lastT1T2
            jbe T1T2loop
            print fld$(sstr$(TotalCycles),COLWIDTH,1)
            print chr$(13,10)

        add PNamePtr,4
        add PTblPtr,4
        mov eax,PTblPtr
        cmp eax,lastproc
        jbe procsloop        

QuitTests:

	print chr$(13,10,"* not including file test", 13, 10)

    ; mov   eax,input(13,10,"Press enter to exit...")
 if PatternInfo
	print chr$(13, 10, "Sizes:", 13, 10)
	;	Tests TEXTEQU <Mainstr/Substr1,Mainstr/Substr2, Mainstr/Substr3, Mainstr/Substr4, mismatch/mmStr_b, mismatch/mmStr_x>
	print "Mainstr    ", 9
	print str$(len(offset Mainstr)), 13, 10
	print "Substr1    ", 9
	print str$(len(offset Substr1)), 13, 10
	print "Substr2    ", 9
	print str$(len(offset Substr2)), 13, 10
;	print "Substr3    ", 9
;	print str$(len(offset Substr3)), 13, 10
	print "Substr4    ", 9
	print str$(len(offset Substr4)), 13, 10, 10
	print "mismatch    ", 9
	print str$(len(offset mismatch)), 13, 10
	print "mmStr_b    ", 9
	print str$(len(offset mmStr_b)), 13, 10
	print "mmStr_x    ", 9
	print str$(len(offset mmStr_x)), 13, 10, 10

	print "File    ", 9
	print str$(len(fbuffer)), 13, 10
	print "WindInc    ", 9
	print str$(len(offset WindInc)), " = "
	print offset WindInc, 13, 10
	
  endif
  print chr$(13, 10, "Press any key to exit...")
  .if fbuffer
	invoke GlobalFree, fbuffer
  .endif
  getkey
  exit

;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
; --------------------- Routines under test ---------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------


;--------  All routines must be written with the same call to be fairly compared  ------- 


ProcMaxSize=0
;---------------All routines must be surrounded by this code-----------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;************************  for these tests, all routines will be prologue:none,etc.
OPTION PROLOGUE:NONE			; turn it off (for all routines being tested)
OPTION EPILOGUE:NONE			;

ShowCpu proc mode:DWORD
  pushad
  sub esp, 80		; create a buffer for the brand string
  mov edi, esp		; point edi to it
  ; push edi
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp

;---------------------------- Routine 1 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------
align 16						;
InStrL	proc lpSource:DWORD, lpPattern:DWORD
	mov		eax, [esp+1*4]		; eax-> lpSource
    mov		edx, [esp+2*4]		; edx->lpPattern
    movzx	ecx, byte ptr [edx] ; ecx->the 1st byte of substring
	mov		[esp+2*4], esi		; saving register esi
    imul	ecx, 1010101h       ; ecx=77 77 77 77h  ; 77h -> ASCII code of "w"
	mov		[esp+1*4], ebx		; saving register ebx
	lea		esi, [edx+1]		; esi->lp Pattern +1
BytesScan:						;
	mov		edx, ecx			; edx=77 77 77 77h  ; 77h -> ASCII code of "w"
	xor		ebx, ebx			;
@@:								;
	xor		ecx, [eax]			;
	add		eax, 4				;              
	add		ecx, 0FEFEFEFFh		;   
    test	ecx, 080808080h		;   
	mov		ecx, edx			; edx=77 77 77 77h  ; 77h -> ASCII code of "w"
  	je		@b					; 
								;
    cmp		[eax-4], dl			; dl ->1st byte of pattern
    lea		eax, [eax-3]	
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]	
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]
	je		@f
    cmp		[eax], dl			; dl ->1st byte of pattern
    lea		eax, [eax+1]
	jne		@b
@@:								; CMP rest  of strings
	add		bl,	 [esi]
	je		@found	
	sub		bl,	 [eax]
	jne		BytesScan
	add		bl,	 [esi+1]
	je		@found	
	sub		bl,	 [eax+1]
	jne		BytesScan
	add		bl,	 [esi+2]
	je		@found	
	sub		bl,	 [eax+2]
	jne		BytesScan
	add		bl,	 [esi+3]
	je		@found	
	sub		bl,	 [eax+3]
	jne		BytesScan	
	add		bl,	 [esi+4]
	je		@found	
	sub		bl,	 [eax+4]
	jne		BytesScan
	add		bl,	 [esi+5]
	je		@found	
	sub		bl,	 [eax+5]
	jne		BytesScan
	add		bl,	 [esi+6]
	je		@found	
	sub		bl,	 [eax+6]
	jne		BytesScan
	add		bl,	 [esi+7]
	je		@found	
	sub		bl,	 [eax+7]
	jne		BytesScan
	add		bl,	 [esi+8]
	je		@found	
	sub		bl,	 [eax+8]
	jne		BytesScan
	mov		edx, 8
@@:	
	add		bl,	 [esi+edx+1]
	je		@found	
	sub		bl,	 [eax+edx+1]
	jne		BytesScan
	add		bl,	 [esi+edx+2]
	je		@found	
	sub		bl,	 [eax+edx+2]
	jne		BytesScan
	add		bl,	 [esi+edx+3]
	je		@found	
	sub		bl,	 [eax+edx+3]
	jne		BytesScan
	add		bl,	 [esi+edx+4]
	je		@found	
	sub		bl,	 [eax+edx+4]
	jne		BytesScan
	add		edx, 4
	jne		@b
@found:	
	mov		ebx, [esp+1*4]	 
	cmp		eax, esi		
	mov		esi, [esp+2*4]	 
	sbb		ecx, ecx
	mov		edx, [esp]	 
	add		eax,  -1		
	add		esp, 3*4 
	and		eax, ecx		;eax-> address of 1st occurrence or 0->Not found   
	jmp		edx				;
InStrL	endp			;


ProcSize = $ - PStart
if ProcSize GT ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 2 ----------------------------------

PStart = $
; --------------  Routine goes here --------------------------------------
align 16
;********************  note  ************************
;   This is Hutch's routine with the first parameter removed so
;    that the call is identical to Lingo's routine for testing
;    the return was also made identical for timing test purposes.
finstr proc psrc:DWORD,patn:DWORD

  ; --------------------------
  ; simplified faster InString algorithm.
  ; --------------------------
  ; arguments
  ; ---------
  ; ***** 1 spos = 1 based index start offset in source address *** removed
  ; 2 psrc = the source address to be searched
  ; 3 patn = the address of the pattern to be searched for
  ; --------------------------
  ; return values
  ; -------------
  ; on match, 1 based index offset from start of source.  **** changes to match Lingo
  ; no match returns zero.
  ; --------------------------
  ; NOTE: The "spos" can be set past the end of the
  ; source buffer which will generate an unhandled
  ; exception. To address this potential problem with
  ; sequential searches, the return value should be
  ; incremented by ONE BYTE at a time which ensures
  ; that the starting position "spos" never goes past
  ; the end of the source buffer.
  ; --------------------------

    mov _ebx, ebx
    nop
    nop
    mov _esi, esi
    nop
    nop
    mov _edi, edi
    nop
    nop
    mov _ebp, ebp
    nop
    nop
    mov _esp, esp

    nop
    nop
    mov edi, [esp+8]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st patn byte in AL
    mov esi, [esp+4]                ; psrc
    ;;; add esi, [esp+4]                ; spos
    sub esi, 4                      ; correct for 1 to 0 based index
                                    ; and dec by 1 for following loop
    mov esp, 80808080h
    mov ebp, 1

; --------------------

  scanloop:
  REPEAT 16
  ; ----------------------------------------------
  ; test if the next 4 bytes contain an ascii zero
  ; ----------------------------------------------
    add esi, 4
    mov edx, [esi]
    lea ecx, [edx-01010101h]
    not edx
    and ecx, esp        ; modify ECX
    test ecx, edx       ; test with no modify
    jnz no_match
  ; ----------------------------------------
  ; test each byte for a patn 1st char match
  ; ----------------------------------------
    movzx ebx, BYTE PTR [esi]
    sub ebx, eax
    jz si0
    movzx ecx, BYTE PTR [esi+1]
    sub ecx, eax
    jz si1
    movzx edx, BYTE PTR [esi+2]
    sub edx, eax
    jz si2
    movzx ecx, BYTE PTR [esi+3]
    sub ecx, eax
    jz si3
  ENDM
    jmp scanloop

; --------------------

  si3:
    add esi, ebp
  si2:
    add esi, ebp
  si1:
    add esi, ebp
  si0:                              ; set index
    xor ebx, ebx

; --------------------

  matchloop:
  REPEAT 8
    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

  ENDM
    jmp matchloop

; --------------------

  match:
    mov esp, _esp
    ;sub esi, [esp+4]                ; psrc
    ; lea eax, [esi+1]
    mov eax, esi
    jmp cleanup

  no_match:
    mov esp, _esp
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 8
finstr endp

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 3 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------
align 16
finstr2 proc psrc:DWORD,patn:DWORD
    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp
    mov _esp, esp

    mov edi, [esp+8]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st pattern byte in AL
    mov esi, [esp+4]                ; psrc
    sub esi, 4 
    mov esp, 80808080h
    mov ebp, 1
	imul eax,01010101h				; get first byte in each byte of eax

  scanloop:
  REPEAT 16

    add esi, 4  	; test if the next 4 bytes contain an ascii zero
    mov edx, [esi]				;
    mov ebx,edx 	;save
    lea ecx, [edx-01010101h]    ;  
    not edx						; 
    and ecx, esp  ; modify ECX	; 
    test ecx, edx ; test with no modify
    jnz no_match

	;mov ebx,[esi]  ; test each byte for a pattern 1st char match
	xor ebx,eax		; turn any matching byte into a zero, else non-zero
	lea ecx,[ebx-01010101h]
	not ebx
	and ecx,esp
	and ecx,ebx
	jnz	foundone
endm
	jmp scanloop	

foundone:
    test cl,cl	; the first non-zero byte is the matching one
    jnz si0
    test ch,ch
    jnz si1
    shr ecx,8
    test ch,ch
    ;test ecx,00800000h
    jnz si2
    ; ----- else, must have been last byte, fall through to si3

  si3:
    add esi, ebp
  si2:
    add esi, ebp
  si1:
    add esi, ebp
  si0:                              ; set index
    xor ebx, ebx

; --------------------

  matchloop:
  REPEAT 16
    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

  ENDM
    jmp matchloop

; --------------------

  match:
    mov esp, _esp
    ;sub esi, [esp+4]                ; psrc
    ; lea eax, [esi+1]
    mov eax, esi
    jmp cleanup

  no_match:
    mov esp, _esp
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 8
finstr2 endp


ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 4 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------
finstr3 proc psrc:DWORD,patn:DWORD
    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp
    mov _esp, esp

    mov edi, [esp+8]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st pattern byte in AL
    mov esi, [esp+4]                ; psrc
    sub esi, 4                      ; correct for 1 to 0 based index
                                    ; and dec by 1 for following loop
    mov esp, 80808080h
    mov ebp, 1
	imul eax,01010101h				; get first byte in each byte of eax

  scanloop:
  REPEAT 16

    add esi, 4  	; test if the next 4 bytes contain an ascii zero
    mov edx, [esi]				; 
    lea ecx, [edx-01010101h]    ;  
    not edx						; 
    and ecx, esp  ; modify ECX	; 
    test ecx, edx ; test with no modify
    jnz no_match

	mov edx,[esi]  ; test each byte for a pattern 1st char match
	xor edx,eax
	lea ecx,[edx-01010101h]
	not edx
	and ecx,esp
	and ecx,edx
	jnz	foundone
endm
	jmp scanloop	

foundone:

    or cl,cl
    jnz si0
    add esi,ebp
    or ch,ch
    jnz si0
    add esi,ebp
    and ecx,00800000h
    jnz si0
    ; ----- else, must have been last byte, fall through to si3

    add esi, ebp
  si0:                              ; set index
    xor ebx, ebx

; --------------------

  matchloop:
  REPEAT 8
    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

  ENDM
    jmp matchloop

; --------------------

  match:
    mov esp, _esp
    ;sub esi, [esp+4]                ; psrc
    ; lea eax, [esi+1]
    mov eax, esi
    jmp cleanup

  no_match:
    mov esp, _esp
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 8
finstr3 endp

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif


;---------------------------- Routine 5 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------
finstr4 proc psrc:DWORD,patn:DWORD
    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp
    mov _esp, esp

    mov edi, [esp+8]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st patn byte in AL
    mov esi, [esp+4]                ; psrc
    sub esi, 4                      ; correct for 1 to 0 based index
                                    ; and dec by 1 for following loop
    mov esp, 80808080h
    mov ebp, 1
  scanloop:
  REPEAT 16
    add esi, 4
	movzx ebx, BYTE PTR [esi]
	test ebx,ebx	
	jz no_match
	sub ebx, eax
    jz si0
    movzx ecx, BYTE PTR [esi+1]
    test ecx,ecx
    jz no_match
    sub ecx, eax
    jz si1
    movzx edx, BYTE PTR [esi+2]
    test edx,edx
    jz no_match
    sub edx, eax
    jz si2
    movzx ecx, BYTE PTR [esi+3]
    test ecx,ecx
    jz no_match
    sub ecx, eax
    jz si3
  ENDM
    jmp scanloop

  si3:    add esi, ebp
  si2:    add esi, ebp
  si1:    add esi, ebp
  si0:    xor ebx, ebx

  matchloop:
  REPEAT 8
    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

  ENDM
    jmp matchloop

; --------------------

  match:
    mov esp, _esp
    ;sub esi, [esp+4]                ; psrc
    ; lea eax, [esi+1]
    mov eax, esi
    jmp cleanup

  no_match:
    mov esp, _esp
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 8
finstr4 endp

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 6 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------
finstr5 proc psrc:DWORD,patn:DWORD
    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp

    mov edi, [esp+8]               ; patn
    mov eax, [edi]       ; set 1st patn byte in AL
    mov esi, [esp+4]                ; psrc
    sub esi, 4                      ; correct for 1 to 0 based index
                                    ; and dec by 1 for following loop
    mov ebp, 1
  scanloop:
  REPEAT 16
    add esi, 4
    mov ebx, [esi]
	or  bl,bl	
	jz no_match
    cmp bl, al
    je si0
    or bh,bh
    jz no_match
    cmp bh, al
    je si1
    mov edx, [esi+2]
    or dl,dl
    jz no_match
    cmp dl, al
    je si2
    or dh,dh
  	jz no_match
    cmp dh,al
    je si3
  ENDM
    jmp scanloop

  si3:    add esi, ebp
  si2:    add esi, ebp
  si1:    add esi, ebp
  si0:    xor ebx, ebx

  matchloop:
  REPEAT 16
    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

  ENDM
    jmp matchloop

; --------------------

  match:
    ;sub esi, [esp+4]                ; psrc
    mov eax, esi
    jmp cleanup

  no_match:
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 8

finstr5 endp

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 7 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------
finstr6 proc psrc:DWORD,patn:DWORD
    mov _ebx, ebx
    mov _esi, esi
    mov _edi, edi
    mov _ebp, ebp
    mov _esp, esp

    mov edi, [esp+8]               ; patn
    movzx eax, BYTE PTR [edi]       ; set 1st pattern byte in AL
    mov esi, [esp+4]                ; psrc
    sub esi, 4                      ; correct for 1 to 0 based index
                                    ; and dec by 1 for following loop
    mov esp, 80808080h
    mov ebp, 1
	imul eax,01010101h				; get first byte in each byte of eax

  scanloop:
  REPEAT 16

    add esi, 4  	; test if the next 4 bytes contain an ascii zero
    mov edx, [esi]				;
    mov ebx,edx 	;save
    lea ecx, [edx-01010101h]    ;  
    not edx						; 
    and ecx, esp  ; modify ECX	; 
    test ecx, edx ; test with no modify
    jnz no_match

	;mov ebx,[esi]  ; test each byte for a pattern 1st char match
	xor ebx,eax		; turn any matching byte into a zero, else non-zero
	lea ecx,[ebx-01010101h]
	not ebx
	and ecx,esp
	and ecx,ebx
	jnz	foundone
endm
	jmp scanloop	

foundone:
    test cl,cl	; the first non-zero byte is the matching one
    jnz si0
    test ch,ch
    jnz si1
    shr ecx,8
    test ch,ch
    ;test ecx,00800000h
    jnz si2
    ; ----- else, must have been last byte, fall through to si3

  si3:
    add esi, ebp
  si2:
    add esi, ebp
  si1:
    add esi, ebp
  si0:                              ; set index
    xor ebx, ebx

; --------------------

  matchloop:
  REPEAT 16
    add ebx, ebp
    movzx edx, BYTE PTR [edi+ebx]
    test edx, edx                   ; test for patn terminator
    jz match                        ; text match if patn terminator found
    movzx ecx, BYTE PTR [esi+ebx]
    cmp ecx, edx                    ; test for match
    jne scanloop

  ENDM
    jmp matchloop

; --------------------

  match:
    mov esp, _esp
    ;sub esi, [esp+4]                ; psrc
    ; lea eax, [esi+1]
    mov eax, esi
    jmp cleanup

  no_match:
    mov esp, _esp
    xor eax, eax

  cleanup:
    mov ebx, _ebx
    mov esi, _esi
    mov edi, _edi
    mov ebp, _ebp

    ret 8
finstr6 endp

align 16
  UseLodsb=	1	; strangely enough, lodsb is a bit faster on Celeron M
  UsePushad =	1			; 1=6 bytes less, no speed difference on P4

InstrJJ proc StartPos:DWORD, lpSource:DWORD ;, lpPattern:DWORD, sMode:DWORD
;	sMode is reserved for a future implementation of a "ignore case of first character" mode
	if UsePushad
		EspOff equ esp+8*4
		pushad
	else
		EspOff equ esp+6*4
		push esi
		push edi
		push ebx					; all registers preserved, except eax = return value
		push ebp					; pushad/popad would cost overall ca. 12 cycles on P4
		push ecx
		push edx
	endif
	; and tjj1, 0
	mov esi, [EspOff+1*4]		; lpSource
	mov edx, [EspOff+2*4]		; lpPattern
	movzx ecx, byte ptr [edx]	; 3 cycles to fill xmm0 with first byte
;	movzx eax, word ptr [edx]	; 3 cycles to fill xmm3 with first word
	; test ah, ah
	; je ByteScan
	mov edi, [edx+1]				; next 4 bytes of pattern
	imul ecx, 01010101h			; propagate lobyte
	movd xmm0, ecx
	pshufd xmm0, xmm0, 0		; xmm0 holds first byte of pattern
	mov eax, edi
	or ebx, -1
;	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
	.if al==0
		inc ebx							; clr ebx, pattern byte 2 is zero
		mov edi, ebx					; clear edi
	.elseif ah==0
		movzx ebx, bl					; byte 3 is zero (= and ebx, 0ffh)
		and edi, ebx
	.else
		bswap eax						; one byte shorter, and a bit faster than shr eax, 16
		test ah, ah						; must come first; if not zero, test new al (highest byte before swap)
		.if Zero?
			movzx ebx, bx			; byte 4 is zero (= and ebx, 0ffffh)
		.else
			test al, al					; highest byte before swap
			.if Zero?
				shr ebx, 8				; byte 5 is zero (= ebx, 0ffffffh but faster and shorter) 
			.endif
		.endif
	.endif
	and edi, ebx					; apply mask for pattern bytes 2-5
	test esi, 15						; aligned?
	je L0							; if yes, clear ebp and go directly into the main loop
	lea ebp, [esi+16]				; save unaligned address+16
	movdqu xmm2, [esi]			; load 16 bytes from current unaligned address
	and esi, -16						; align esi downwards
	jmp Lu
	Repeat 1
	nop								; 4=1666, 0=1672
	Endm
L0:	xor ebp, ebp					; clear the alignment flag ----------------------------------------------------------------------
L1:	movdqa xmm2, [esi]
Lu:	movdqa xmm1, xmm0			; xmm0 has first byte of pattern
	lea esi, [esi+16]				; position in mainstring (moving up/down lea or add costs cycles; add esi, 16 is 5 cycles slower on CM, 8 on P4)
	pcmpeqb xmm1, xmm2		; compare memory to pattern byte
	pmovmskb edx, xmm1		; set byte mask in edx for search pattern byte
	pcmpeqb xmm1, xmm2		; look for zero byte (xmm1 is either 0 or ff)
	pmovmskb eax, xmm1		; set byte mask in eax for zero delimiter byte
	test eax, eax					; db 02eh	; branch hint: not taken, no effect
	jne ZBF						; zero byte found? check/clear ebp, then ChkNull
	test edx, edx					; db 03eh	; branch hint: taken, no effect
	je L1							; pattern byte found? no=go back, yes=repeat the exercise with a word

@@:	test ebp, ebp					; 0=aligned from the beginning, or at least second loop
	jne EbpChk					; rare case, once per algo and only if Mainstring is unaligned - so try not to branch

@@:
	REPEAT 3						; 4 same as 3, 1+5 worse: 1=+300, 2=+30
	  bsf ecx, edx					; bit scan for the index ---------------------------------------------------------
	  btr edx, ecx					; clear bit ecx in edx (no add ecx, ebp here: 0.5*171=+85 cycles)
	  mov eax, [esi+ecx-14-1]	; first unaligned chunk contains match; this loop 171 times for TestSubX
	  and eax, ebx					; apply mask
	  cmp eax, edi
	  je FoundPattern
	  test edx, edx
	  je L1							; mysteriously, jmp L0 was consistently ca. 10 cycles faster than jmp L1...
	ENDM
	jmp @B							; 0=no more hits in these 16 bytes, go back searching (this order is here a lot faster)

EbpChk:
	sub ebp, esi					; ebp>0, might be first unaligned loop
	jns @F
	xor ebp, ebp					; ebp<esi: we are at least in the second loop, i.e. 16-byte aligned
	; jmp @B		; needed??	

@@:	bsf ecx, edx						; bit scan with misalignment offset in ebp -----------------------
	btr edx, ecx						; clear bit ecx in edx
	add ecx, ebp					; ebp is the misalignment offset, needed for the whole bitscan loop
	mov eax, [esi+ecx-15]			; first unaligned chunk contains match
	and eax, ebx					; apply mask
	cmp eax, edi
	je FoundPatternSubEcx		; corrects increased ecx

BadLuck:
	if 0
	xor eax, eax					; default: no match
	cmp ebx, -123					; flag end??
	je NoMatch
	endif

	test edx, edx
	je L0						; unaligned bit scan end, time to clear ebp in L0 -------------
	jmp @B

ZBF:	sub ebp, esi				; ebp>0, might be first unaligned loop
	jns ChkNull
	xor ebp, ebp				; ebp<esi: we are at least in the second loop, i.e. 16-byte aligned

ChkNull:							; this branch only if a nullbyte was found in Mainstring
	bsf ebx, eax				; nullbyte index to ebx
	xor eax, eax				; default: 0=no match
	test edx, edx				; edx holds pattern index
	je NoMatch
	bsf ecx, edx					; pattern word index in ecx
	cmp ebx, ecx				; null before pattern word: get outta here
	jb NoMatch
	add ecx, ebp				; jmp FoundPattern is slower
;	m2m ebx, -123				; flag end
	;				0						 16			 32			48 51
	;SmSrcU	db "123456789012a4X67890?2345b78901234X67890c234567890X6789012345", 0 ;, "X67890"
	;SmPat7	db "X678901", 0
FoundPatternSubEcx:
	sub ecx, ebp
FoundPattern:						; we need to check the rest of the string here
	cmp edi, 0ffffffh			; 3 bytes = 5-byte pattern, OK
	jbe Match
	push esi
	push ebx
	lea ebx, [esi+ecx-16+4]			; Mainstring: 1 byte covered by inner loop, 4 by edi, so we check from byte 6 onwards
	mov esi, [EspOff+2*4+4+4]		; Pattern
	add ebx, ebp
	add esi, 5
@@:
	if UseLodsb
		lodsb			; sometimes a few cycles faster (but difficult to prove)
		test al, al		; this cannot be shifted below because of the rare case of equality after the zero delimiter:
		je @F			; db "Mainstr", 0, "abc" ... db "str", 0, "abx"  would crash
	else
		movzx eax, byte ptr [esi]		; esi=Substr (mov al is a few cycles slower)
		test eax, eax
		je @F
		inc esi
	endif
	inc ebx
	cmp al, [ebx]						; ebx=Mainstr
	je @B

@@:	pop ebx
	pop esi
	jne BadLuck						; test al, al not needed, flags still valid

Match:
	sub esi, [EspOff+1*4]			; lpSource: subtract original src pointer
	lea eax, [esi+ecx-15]				; and adjust for the index
	add eax, ebp						; ebp = offset in first unaligned chunk

NoMatch:
	if UsePushad
		mov [esp+32-4], eax		; popped eax will contain current eax
		popad
	else
	pop edx								; 6 registers
	pop ecx
	pop ebp
	pop ebx
	pop edi
	pop esi
	endif
	; inc tjj1
	if 0
	.if tjj1
		nop			; replace with int 3 to see from where it is called
	.endif
	endif
	ret 2*4							; 4 arguments
InstrJJ endp
InstrJJe:

align 16
InstrJJw proc StartPos:DWORD, lpSource:DWORD	;, lpPattern:DWORD, sMode:DWORD
;	sMode is reserved for a future implementation of a "ignore case of first character" mode
	push esi
	push edi
	push ebx					; all registers preserved, except eax = return value
	push ebp
	push ecx
	push edx
	; and tjj1, 0
	mov esi, [esp+6*4+1*4]		; lpSource
	mov edx, [esp+6*4+2*4]		; lpPattern
	movzx eax, word ptr [edx]	; 3 cycles to fill xmm3 with first word
	test ah, ah
	je ByteScan
	imul eax, 00010001h			; propagate loword
	mov edi, [edx+2]				; next 4 bytes of pattern
	movd xmm3, eax
	or ebx, -1
	mov eax, edi
	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
	.if al==0
		xor ebx, ebx					; pattern byte 3 is zero
		mov edi, ebx					; clear edi
	.elseif ah==0
		movzx ebx, bl					; byte 4 is zero (= and ebx, 0ffh)
		and edi, ebx
	.else
		bswap eax						; one byte shorter, and a bit faster than shr eax, 16
		test ah, ah						; must come first; if not zero, test new al (highest byte before swap)
		.if Zero?
			movzx ebx, bx			; byte 5 is zero (= and ebx, 0ffffh)
		.else
			test al, al					; highest byte before swap
			.if Zero?
				shr ebx, 8				; byte 6 is zero (= ebx, 0ffffffh but faster and shorter) 
			.endif
		.endif
	.endif
	and edi, ebx					; apply mask for pattern bytes 2-5
	test esi, 15						; aligned?
	je L0							; if yes, clear ebp and go directly into the main loop
	movdqu xmm1, [esi]			; load 16 bytes from current unaligned address
	movdqu xmm4, [esi+1]		; load another16 bytes
	lea ebp, [esi+16]				; save unaligned address+16
	and esi, -16						; align esi downwards
	movdqa xmm2, xmm1			; load 16 bytes for testing the zero delimiter
	jmp Lu
;	repeat 0
;	nop								; 0=2530, 1=2540, 2=... alignment doesn't matter on a modern CPU
;	endm
L0:	xor ebp, ebp					; clear the alignment flag ----------------------------------------------------------------------
L1:	movdqa xmm1, [esi]			; load 16 bytes from current aligned address; pshufd xmm1, [esi], 0E4h ([url=http://www.mark.masmcode.com/]Mark[/url]) is 200 cycles slower
	movdqu xmm4, [esi+1]		; load another 16 bytes - must be in the middle
	movdqa xmm2, [esi]			; load 16 bytes for testing the zero delimiter - faster than movdqa xmm2, xmm1, even on Celeron M!
Lu:	pcmpeqw xmm1, xmm3		; compare packed words in xmm1 and xmm3 for equality
	pmovmskb edx, xmm1		; set byte mask in edx for search pattern word
	pcmpeqw xmm4, xmm3		; compare packed words in xmm4 and xmm3 for equality
	lea esi, [esi+16]				; position in mainstring (moving up/down lea or add costs cycles; add esi, 16 is 5 cycles slower on CM, 8 on P4)
	pmovmskb ecx, xmm4			; set byte mask in ecx for search pattern word
	pcmpeqb xmm2, xmm1		; xmm1 is filled with either 0 or FF; if it's FF, the byte at that position cannot be zero
	pmovmskb eax, xmm2		; set byte mask in eax for zero delimiter byte
	shl ecx, 1						; adjust for esi+1 (add ecx, ecx is a lot slower)
	test eax, eax
	jne ZBF						; zero byte found? check/clear ebp, then ChkNull
	or edx, ecx						; one of them needs to have the word
	je L1							; 0=no pattern byte found, go back ------------------------------------------------------

@@:	test ebp, ebp					; 0=aligned from the beginning, or at least second loop
	jne EbpChk					; rare case, once per algo and only if Mainstring is unaligned - so try not to branch

@@:	bsf ecx, edx						; bit scan for the index ---------------------------------------------------------
	btr edx, ecx						; clear bit ecx in edx (no add ecx, ebp here: 0.5*171=+85 cycles)
	mov eax, [esi+ecx-14]			; first unaligned chunk contains match; this loop 171 times for TestSubX
	and eax, ebx					; apply mask
	cmp eax, edi
	je FoundPattern
	test edx, edx
	jnz @B							; 0=no more hits in these 16 bytes, go back searching (reversing order is a lot slower)
	; mysteriously, jmp L0 is consistently ca. 10 cycles faster than jmp L1...
	jmp L0							; bit scan end -----------------------------------------------------------------------

EbpChk:
	sub ebp, esi					; ebp>0, might be first unaligned loop
	jns @F
	xor ebp, ebp					; ebp<esi: we are at least in the second loop, i.e. 16-byte aligned
	jmp @B	

@@:	bsf ecx, edx						; bit scan with misalignment offset in ebp -----------------------
	btr edx, ecx						; clear bit ecx in edx
	add ecx, ebp					; ebp is the misalignment offset, needed for the whole bitscan loop
	mov eax, [esi+ecx-14]			; first unaligned chunk contains match
	and eax, ebx					; apply mask
	cmp eax, edi
	je FoundPattern

BadLuck:
	test edx, edx
	jnz @B
	jmp L0							; unaligned bit scan end, time to clear ebp in L0 -------------

ZBF:	sub ebp, esi				; ebp>0, might be first unaligned loop
	jns ChkNull
	xor ebp, ebp				; ebp<esi: we are at least in the second loop, i.e. 16-byte aligned

ChkNull:							; this branch only if a nullbyte was found in Mainstring
	mov ebx, eax				; position of zero byte
	xor eax, eax				; default: 0=no match
	or edx, ecx					; one of them needs to have the word
	je NoMatch
	bsf ebx, ebx				; nullbyte index in ebx
	bsf ecx, edx					; pattern word index in ecx
	cmp ebx, ecx				; null before pattern word: get outta here
	jb NoMatch
	add ecx, ebp				; lea ecx, [ecx+ebp] 2 bytes longer and a bit slower

FoundPattern:						; we need to check the rest of the string here
	sub ecx, ebp
	cmp edi, 0ffffffh			; 3 bytes = 5-byte pattern, OK
	jbe Match
	push esi
	push ebx
	lea ebx, [esi+ecx-16+2+3]			; Mainstring: 2 bytes covered by inner loop, 4 by edi, so we check from byte 7 onwards
	mov esi, [esp+6*4+2*4+4+4]		; Pattern
	add ebx, ebp
	add esi, 6
@@:
	if UseLodsb
		lodsb			; a few cycles faster (but difficult to prove)
		test al, al		; this cannot be shifted below because of the rare case of equality after the zero delimiter:
		je @F			; db "Mainstr", 0, "abc" ... db "str", 0, "abx"  would crash
	else
		movzx eax, byte ptr [esi]		; esi=Substr (mov al is a few cycles slower)
		test eax, eax
		je @F
		inc esi
	endif
	inc ebx
	cmp al, [ebx]						; ebx=Mainstr
	je @B

@@:	pop ebx
	pop esi
	jne BadLuck						; test al, al not needed, flags still valid

Match:
	sub esi, [esp+5*4+2*4]			; lpSource: subtract original src pointer
	lea eax, [esi+ecx-15]				; and adjust for the index
	add eax, ebp						; ebp = offset in first unaligned chunk

NoMatch:
	pop edx								; 6 registers
	pop ecx
	pop ebp
	pop ebx
	pop edi
	pop esi
	ret 2*4							; 2 arguments

ByteScan:
	imul eax, 01010101h			; propagate lobyte
	movd xmm3, eax
	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
@@:	movdqu xmm1, [esi]			; load 16 bytes from current unaligned address
	movdqa xmm2, xmm1			; save 16 bytes for testing the zero delimiter
	lea esi, [esi+16]				; len counter (moving up/down lea or add costs cycles)
	pcmpeqb xmm1, xmm3		; compare packed bytes in xmm1 and xmm3 (elephant) for equality
	pcmpeqb xmm2, xmm1		; xmm1 is filled with either 0 or FF; if it's FF, the byte at that position cannot be zero
	pmovmskb edx, xmm1		; set byte mask in edx for search pattern word
	pmovmskb ecx, xmm2			; set byte mask (bits 0...15) in ecx for zero delimiter
	test ecx, ecx					; zero byte found?
	jnz @F							; check ebp, then ChkNull
	test edx, edx					; pattern found?
	jz @B							; 0=no pattern byte found, go back

@@:	xor eax, eax					; default; no match
	bsf edx, edx					; 34", 0, "X6
	test ecx, ecx					; nullbyte found?
	je @F
	bsf ecx, ecx						; if yes, we need to check if
	cmp ecx, edx					; it comes before or after the match
	jb NoMatch

@@:	lea eax, [esi+edx-15]
	sub eax, [esp+5*4+2*4]
	jmp NoMatch

InstrJJw endp
InstrJJwe:

InstrM32 proc lpSource:DWORD, lpPattern:DWORD
	mov ecx, [esp+1*4]		; lpSource
	mov edx, [esp+2*4]		; lpPattern
	push edx
	push ecx
	push 1
	mov eax, AuxAdd
	call eax
	;invoke InString, 1, ecx, edx
ret 2*4
InstrM32 endp

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

;---------------------------- Routine 8 ----------------------------------
align 16
PStart = $
; --------------  Routine goes here --------------------------------------

ProcSize = $ - PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

;-------------------------------------------------------------------------------


;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
; --------------------- End of Routines under test --------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------

align 16
PStart = $
OVH proc xstr1:dword, xstr2:dword
   ret 8
OVH EndP 
ProcSize=$-PStart
if ProcSize gt ProcMaxSize
   ProcMaxSize=ProcSize
endif

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
.data
MaximumProcSize dd ProcMaxSize
.code


;--------------------------  procs will be moved to here for testing  ------------------------------------
align 16
TheProc:
db ProcMaxSize+16 dup (0)

;-------------------------------------------------------------------------------

end start
OPT_Assembler ml
OPT_Res	0
OPT_WAIT	0
OPT_Tmp2Asm	1


Avg Mainstr=	5.9	(=match plus len of pattern)
Avg Pattern=	3.47
Total calls=	13221477



